#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/accounts_dbus_common.h"

namespace Kiran {
namespace SystemDaemon {

class AccountsProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<AccountsProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<AccountsProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void GetNonSystemUsers(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetNonSystemUsers_finish (
        std::vector<Glib::DBusObjectPathString> &users,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::DBusObjectPathString>
    GetNonSystemUsers_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserById(
        guint64 uid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserById_finish (
        Glib::DBusObjectPathString &user,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::DBusObjectPathString
    FindUserById_sync(
        guint64 uid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserByName(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserByName_finish (
        Glib::DBusObjectPathString &user,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::DBusObjectPathString
    FindUserByName_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserByAuthData(
        gint32 mode,
        const Glib::ustring & data_id,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void FindUserByAuthData_finish (
        Glib::DBusObjectPathString &user,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::DBusObjectPathString
    FindUserByAuthData_sync(
        gint32 mode,        const Glib::ustring & data_id,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CreateUser(
        const Glib::ustring & name,
        const Glib::ustring & realname,
        gint32 account_type,
        gint64 uid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CreateUser_finish (
        Glib::DBusObjectPathString &user,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::DBusObjectPathString
    CreateUser_sync(
        const Glib::ustring & name,        const Glib::ustring & realname,        gint32 account_type,        gint64 uid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DeleteUser(
        guint64 uid,
        bool remove_files,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DeleteUser_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DeleteUser_sync(
        guint64 uid,        bool remove_files,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    sigc::signal<void, Glib::DBusObjectPathString > UserAdded_signal;
    sigc::signal<void, Glib::DBusObjectPathString > UserDeleted_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    AccountsProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

};

}// SystemDaemon
}// Kiran

