static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Appearance">

        <method name="GetThemes">
            <arg type="i" name="type" direction="in">
                <summary>The theme type that contains gtk, icon and cursor, etc.</summary>
            </arg>
            <arg type="s" name="theme_json" direction="out">
                <summary>The theme info that contain name and path.</summary>
            </arg>
            <description>Get the theme info.</description>
        </method>

        <method name="SetTheme">
            <arg type="i" name="type" direction="in">
                <summary>The theme type that contains gtk, icon and cursor, etc.</summary>
            </arg>
            <arg type="s" name="theme_name" direction="in">
                <summary>The theme name.</summary>
            </arg>
            <description>Set the theme name for the type.</description>
        </method>

        <method name="GetTheme">
            <arg type="i" name="type" direction="in">
                <summary>The theme type that contains gtk, icon and cursor, etc.</summary>
            </arg>
            <arg type="s" name="theme_name" direction="out">
                <summary>The theme name.</summary>
            </arg>
            <description>Get the theme name for the type.</description>
        </method>

        <method name="GetFont">
            <arg type="i" name="type" direction="in">
                <summary>The font type that contains application font, document font, desktop font and monospace font, etc.</summary>
            </arg>
            <arg type="s" name="font" direction="out">
                <summary>The font that contain name and size, for example 'San 10'.</summary>
            </arg>
            <description>Get the font for the type.</description>
        </method>

        <method name="SetFont">
            <arg type="i" name="type" direction="in">
                <summary>The font type that contains application font, document font, desktop font and monospace font, etc.</summary>
            </arg>
            <arg type="s" name="font" direction="in">
                <summary>The font, for example 'San 10'.</summary>
            </arg>
            <description>Set the font for the type.</description>
        </method>

        <method name="SetDesktopBackground">
            <arg type="s" name="desktop_background" direction="in">
                <summary>File path of desktop background.</summary>
            </arg>
            <description>Set the desktop background.</description>
        </method>

        <method name="SetLockScreenBackground">
            <arg type="s" name="lock_screen_background" direction="in">
                <summary>File path of lock screen background.</summary>
            </arg>
            <description>Set the lock screen background.</description>
        </method>

        <property name="desktop_background" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The file path of desktop background.</description>
        </property>

        <property name="lock_screen_background" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The file path of lock screen background.</description>
        </property>

        <signal name="ThemeChanged">
            <arg name="type" type="i">
                <summary>The theme type.</summary>
            </arg>
            <arg name="theme_name" type="s">
                <summary>The new theme name.</summary>
            </arg>
        </signal>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/appearance_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::AppearanceStub::AppearanceStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Appearance")
{
    ThemeChanged_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AppearanceStub::ThemeChanged_emitter),
            std::vector<Glib::ustring>({""})) );
    ThemeChanged_selectiveSignal.connect(sigc::mem_fun(this, &AppearanceStub::ThemeChanged_emitter));
}

Kiran::SessionDaemon::AppearanceStub::~AppearanceStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::AppearanceStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &AppearanceStub::on_method_call),
            sigc::mem_fun(this, &AppearanceStub::on_interface_get_property),
            sigc::mem_fun(this, &AppearanceStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Appearance"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::AppearanceStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::AppearanceStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("GetThemes") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        MethodInvocation methodInvocation(invocation);
        GetThemes(
            (p_type),
            methodInvocation);
    }

    if (method_name.compare("SetTheme") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        Glib::Variant<Glib::ustring> base_theme_name;
        parameters.get_child(base_theme_name, 1);
        Glib::ustring p_theme_name = specialGetter(base_theme_name);

        MethodInvocation methodInvocation(invocation);
        SetTheme(
            (p_type),
            (p_theme_name),
            methodInvocation);
    }

    if (method_name.compare("GetTheme") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        MethodInvocation methodInvocation(invocation);
        GetTheme(
            (p_type),
            methodInvocation);
    }

    if (method_name.compare("GetFont") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        MethodInvocation methodInvocation(invocation);
        GetFont(
            (p_type),
            methodInvocation);
    }

    if (method_name.compare("SetFont") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        Glib::Variant<Glib::ustring> base_font;
        parameters.get_child(base_font, 1);
        Glib::ustring p_font = specialGetter(base_font);

        MethodInvocation methodInvocation(invocation);
        SetFont(
            (p_type),
            (p_font),
            methodInvocation);
    }

    if (method_name.compare("SetDesktopBackground") == 0) {
        Glib::Variant<Glib::ustring> base_desktop_background;
        parameters.get_child(base_desktop_background, 0);
        Glib::ustring p_desktop_background = specialGetter(base_desktop_background);

        MethodInvocation methodInvocation(invocation);
        SetDesktopBackground(
            (p_desktop_background),
            methodInvocation);
    }

    if (method_name.compare("SetLockScreenBackground") == 0) {
        Glib::Variant<Glib::ustring> base_lock_screen_background;
        parameters.get_child(base_lock_screen_background, 0);
        Glib::ustring p_lock_screen_background = specialGetter(base_lock_screen_background);

        MethodInvocation methodInvocation(invocation);
        SetLockScreenBackground(
            (p_lock_screen_background),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::AppearanceStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("desktop_background") == 0) {

        property = Glib::Variant<Glib::ustring>::create((desktop_background_get()));
    }

    if (property_name.compare("lock_screen_background") == 0) {

        property = Glib::Variant<Glib::ustring>::create((lock_screen_background_get()));
    }

}

bool Kiran::SessionDaemon::AppearanceStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}

void Kiran::SessionDaemon::AppearanceStub::ThemeChanged_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,gint32 type, const Glib::ustring & theme_name)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<gint32>::create((type)));;
    paramsList.push_back(Glib::Variant<Glib::ustring>::create((theme_name)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Appearance",
                    "ThemeChanged",
                    bus_name,
                    params);
        }
    }
}


bool Kiran::SessionDaemon::AppearanceStub::desktop_background_set(const Glib::ustring & value)
{
    if (desktop_background_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((desktop_background_get()));

        emitSignal("desktop_background", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::AppearanceStub::lock_screen_background_set(const Glib::ustring & value)
{
    if (lock_screen_background_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((lock_screen_background_get()));

        emitSignal("lock_screen_background", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::AppearanceStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
