#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/audio_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {

class AudioProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<AudioProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<AudioProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void GetDefaultSink(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDefaultSink_finish (
        Glib::ustring &sink,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetDefaultSink_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDefaultSink(
        guint32 sink_index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDefaultSink_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetDefaultSink_sync(
        guint32 sink_index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinks(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinks_finish (
        std::vector<Glib::ustring> &sinks,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetSinks_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSink(
        guint32 index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSink_finish (
        Glib::ustring &sink,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetSink_sync(
        guint32 index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDefaultSource(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDefaultSource_finish (
        Glib::ustring &source,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetDefaultSource_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDefaultSource(
        guint32 source_index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDefaultSource_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetDefaultSource_sync(
        guint32 source_index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSources(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSources_finish (
        std::vector<Glib::ustring> &sources,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetSources_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSource(
        guint32 index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSource_finish (
        Glib::ustring &source,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetSource_sync(
        guint32 index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinkInputs(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinkInputs_finish (
        std::vector<Glib::ustring> &sink_inputs,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetSinkInputs_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinkInput(
        guint32 index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSinkInput_finish (
        Glib::ustring &sink_input,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetSinkInput_sync(
        guint32 index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSourceOutputs(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSourceOutputs_finish (
        std::vector<Glib::ustring> &soruce_outputs,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetSourceOutputs_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSourceOutput(
        guint32 index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSourceOutput_finish (
        Glib::ustring &source_output,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetSourceOutput_sync(
        guint32 index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    guint32 state_get(bool *ok = nullptr);
    sigc::signal<void> &state_changed() {
        return m_state_changed;
    }

    sigc::signal<void, guint32 > DefaultSinkChange_signal;
    sigc::signal<void, guint32 > DefaultSourceChange_signal;
    sigc::signal<void, guint32 > SinkAdded_signal;
    sigc::signal<void, guint32 > SinkDelete_signal;
    sigc::signal<void, guint32 > SourceAdded_signal;
    sigc::signal<void, guint32 > SourceDelete_signal;
    sigc::signal<void, guint32 > SinkInputAdded_signal;
    sigc::signal<void, guint32 > SinkInputDelete_signal;
    sigc::signal<void, guint32 > SourceOutputAdded_signal;
    sigc::signal<void, guint32 > SourceOutputDelete_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    AudioProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_state_changed;
};

}// SessionDaemon
}// Kiran

