static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Audio">

        <method name="GetDefaultSink">
            <arg type="s" name="sink" direction="out">
                <summary>The object path of the default sink.</summary>
            </arg>
            <description>Get the object path of the default sink.</description>
        </method>

        <method name="SetDefaultSink">
            <arg type="u" name="sink_index" direction="in">
                <summary>The index of the sink.</summary>
            </arg>
            <description>Set the default sink by index.</description>
        </method>

        <method name="GetSinks">
            <arg type="as" name="sinks" direction="out">
                <summary>The object path of all sinks</summary>
            </arg>
            <description>Get the object path of all sinks.</description>
        </method>

        <method name="GetSink">
            <arg type="u" name="index" direction="in">
                <summary>The sink index</summary>
            </arg>
            <arg type="s" name="sink" direction="out">
                <summary>The object path of the sink</summary>
            </arg>
            <description>Get the object path of the sink by index .</description>
        </method>

        <method name="GetDefaultSource">
            <arg type="s" name="source" direction="out">
                <summary>The object path of the default source.</summary>
            </arg>
            <description>Get the object path of the default source.</description>
        </method>

        <method name="SetDefaultSource">
            <arg type="u" name="source_index" direction="in">
                <summary>The index of the source.</summary>
            </arg>
            <description>Set the default source by index.</description>
        </method>

        <method name="GetSources">
            <arg type="as" name="sources" direction="out">
                <summary>The object path of all sources</summary>
            </arg>
            <description>Get the object path of all sources.</description>
        </method>

        <method name="GetSource">
            <arg type="u" name="index" direction="in">
                <summary>The source index.</summary>
            </arg>
            <arg type="s" name="source" direction="out">
                <summary>The object path of the source.</summary>
            </arg>
            <description>Get the object path of the source by index .</description>
        </method>

        <method name="GetSinkInputs">
            <arg type="as" name="sink_inputs" direction="out">
                <summary>The object path of all sink inputs</summary>
            </arg>
            <description>Get the object path of all sink inputs.</description>
        </method>

        <method name="GetSinkInput">
            <arg type="u" name="index" direction="in">
                <summary>The sink input index.</summary>
            </arg>
            <arg type="s" name="sink_input" direction="out">
                <summary>The object path of the sink input.</summary>
            </arg>
            <description>Get the object path of the sink input by index .</description>
        </method>

        <method name="GetSourceOutputs">
            <arg type="as" name="soruce_outputs" direction="out">
                <summary>The object path of all source outputs</summary>
            </arg>
            <description>Get the object path of all source outputs.</description>
        </method>

        <method name="GetSourceOutput">
            <arg type="u" name="index" direction="in">
                <summary>The source output index.</summary>
            </arg>
            <arg type="s" name="source_output" direction="out">
                <summary>The object path of the source output.</summary>
            </arg>
            <description>Get the object path of the source output by index .</description>
        </method>

        <signal name="DefaultSinkChange">
            <arg type="u" name="index">
                <description>If the index is equal to PA_INVALID_INDEX, then the default sink is not set.</description>
            </arg>
        </signal>
        <signal name="DefaultSourceChange">
            <arg type="u" name="index">
                <description>If the index is equal to PA_INVALID_INDEX, then the default sink is not set.</description>
            </arg>
        </signal>

        <signal name="SinkAdded">
            <arg type="u" name="index" />
        </signal>

        <signal name="SinkDelete">
            <arg type="u" name="index" />
        </signal>

        <signal name="SourceAdded">
            <arg type="u" name="index" />
        </signal>

        <signal name="SourceDelete">
            <arg type="u" name="index" />
        </signal>

        <signal name="SinkInputAdded">
            <arg type="u" name="index" />
        </signal>

        <signal name="SinkInputDelete">
            <arg type="u" name="index" />
        </signal>

        <signal name="SourceOutputAdded">
            <arg type="u" name="index" />
        </signal>

        <signal name="SourceOutputDelete">
            <arg type="u" name="index" />
        </signal>

        <property name="state" type="u" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>Refer to enum PulseState in audio-i.h. The backend is available only when the state is PULSE_STATE_READY.</description>
        </property>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/audio_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::AudioStub::AudioStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Audio")
{
    DefaultSinkChange_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::DefaultSinkChange_emitter),
            std::vector<Glib::ustring>({""})) );
    DefaultSinkChange_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::DefaultSinkChange_emitter));
    DefaultSourceChange_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::DefaultSourceChange_emitter),
            std::vector<Glib::ustring>({""})) );
    DefaultSourceChange_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::DefaultSourceChange_emitter));
    SinkAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SinkAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    SinkAdded_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SinkAdded_emitter));
    SinkDelete_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SinkDelete_emitter),
            std::vector<Glib::ustring>({""})) );
    SinkDelete_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SinkDelete_emitter));
    SourceAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SourceAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    SourceAdded_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SourceAdded_emitter));
    SourceDelete_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SourceDelete_emitter),
            std::vector<Glib::ustring>({""})) );
    SourceDelete_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SourceDelete_emitter));
    SinkInputAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SinkInputAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    SinkInputAdded_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SinkInputAdded_emitter));
    SinkInputDelete_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SinkInputDelete_emitter),
            std::vector<Glib::ustring>({""})) );
    SinkInputDelete_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SinkInputDelete_emitter));
    SourceOutputAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SourceOutputAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    SourceOutputAdded_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SourceOutputAdded_emitter));
    SourceOutputDelete_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &AudioStub::SourceOutputDelete_emitter),
            std::vector<Glib::ustring>({""})) );
    SourceOutputDelete_selectiveSignal.connect(sigc::mem_fun(this, &AudioStub::SourceOutputDelete_emitter));
}

Kiran::SessionDaemon::AudioStub::~AudioStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::AudioStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &AudioStub::on_method_call),
            sigc::mem_fun(this, &AudioStub::on_interface_get_property),
            sigc::mem_fun(this, &AudioStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Audio"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::AudioStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::AudioStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("GetDefaultSink") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetDefaultSink(
            methodInvocation);
    }

    if (method_name.compare("SetDefaultSink") == 0) {
        Glib::Variant<guint32> base_sink_index;
        parameters.get_child(base_sink_index, 0);
        guint32 p_sink_index = specialGetter(base_sink_index);

        MethodInvocation methodInvocation(invocation);
        SetDefaultSink(
            (p_sink_index),
            methodInvocation);
    }

    if (method_name.compare("GetSinks") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetSinks(
            methodInvocation);
    }

    if (method_name.compare("GetSink") == 0) {
        Glib::Variant<guint32> base_index;
        parameters.get_child(base_index, 0);
        guint32 p_index = specialGetter(base_index);

        MethodInvocation methodInvocation(invocation);
        GetSink(
            (p_index),
            methodInvocation);
    }

    if (method_name.compare("GetDefaultSource") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetDefaultSource(
            methodInvocation);
    }

    if (method_name.compare("SetDefaultSource") == 0) {
        Glib::Variant<guint32> base_source_index;
        parameters.get_child(base_source_index, 0);
        guint32 p_source_index = specialGetter(base_source_index);

        MethodInvocation methodInvocation(invocation);
        SetDefaultSource(
            (p_source_index),
            methodInvocation);
    }

    if (method_name.compare("GetSources") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetSources(
            methodInvocation);
    }

    if (method_name.compare("GetSource") == 0) {
        Glib::Variant<guint32> base_index;
        parameters.get_child(base_index, 0);
        guint32 p_index = specialGetter(base_index);

        MethodInvocation methodInvocation(invocation);
        GetSource(
            (p_index),
            methodInvocation);
    }

    if (method_name.compare("GetSinkInputs") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetSinkInputs(
            methodInvocation);
    }

    if (method_name.compare("GetSinkInput") == 0) {
        Glib::Variant<guint32> base_index;
        parameters.get_child(base_index, 0);
        guint32 p_index = specialGetter(base_index);

        MethodInvocation methodInvocation(invocation);
        GetSinkInput(
            (p_index),
            methodInvocation);
    }

    if (method_name.compare("GetSourceOutputs") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetSourceOutputs(
            methodInvocation);
    }

    if (method_name.compare("GetSourceOutput") == 0) {
        Glib::Variant<guint32> base_index;
        parameters.get_child(base_index, 0);
        guint32 p_index = specialGetter(base_index);

        MethodInvocation methodInvocation(invocation);
        GetSourceOutput(
            (p_index),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::AudioStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("state") == 0) {

        property = Glib::Variant<guint32>::create((state_get()));
    }

}

bool Kiran::SessionDaemon::AudioStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}

void Kiran::SessionDaemon::AudioStub::DefaultSinkChange_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "DefaultSinkChange",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::DefaultSourceChange_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "DefaultSourceChange",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SinkAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SinkAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SinkDelete_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SinkDelete",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SourceAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SourceAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SourceDelete_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SourceDelete",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SinkInputAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SinkInputAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SinkInputDelete_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SinkInputDelete",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SourceOutputAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SourceOutputAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::AudioStub::SourceOutputDelete_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,guint32 index)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<guint32>::create((index)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Audio",
                    "SourceOutputDelete",
                    bus_name,
                    params);
        }
    }
}


bool Kiran::SessionDaemon::AudioStub::state_set(guint32 value)
{
    if (state_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((state_get()));

        emitSignal("state", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::AudioStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
