#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/audio_stream_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {
namespace Audio {

class StreamProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<StreamProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<StreamProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void SetVolume(
        double volume,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetVolume_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetVolume_sync(
        double volume,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetMute(
        bool mute,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetMute_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetMute_sync(
        bool mute,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    guint32 index_get(bool *ok = nullptr);
    sigc::signal<void> &index_changed() {
        return m_index_changed;
    }

    Glib::ustring name_get(bool *ok = nullptr);
    sigc::signal<void> &name_changed() {
        return m_name_changed;
    }

    bool mute_get(bool *ok = nullptr);
    sigc::signal<void> &mute_changed() {
        return m_mute_changed;
    }

    double volume_get(bool *ok = nullptr);
    sigc::signal<void> &volume_changed() {
        return m_volume_changed;
    }

    Glib::ustring application_name_get(bool *ok = nullptr);
    sigc::signal<void> &application_name_changed() {
        return m_application_name_changed;
    }

    Glib::ustring icon_name_get(bool *ok = nullptr);
    sigc::signal<void> &icon_name_changed() {
        return m_icon_name_changed;
    }

    guint32 state_get(bool *ok = nullptr);
    sigc::signal<void> &state_changed() {
        return m_state_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    StreamProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_index_changed;
    sigc::signal<void> m_name_changed;
    sigc::signal<void> m_mute_changed;
    sigc::signal<void> m_volume_changed;
    sigc::signal<void> m_application_name_changed;
    sigc::signal<void> m_icon_name_changed;
    sigc::signal<void> m_state_changed;
};

}// Audio
}// SessionDaemon
}// Kiran

