static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Audio.Stream">

        <method name="SetVolume">
            <arg type="d" name="volume" direction="in">
                <summary>The volume of the stream.</summary>
            </arg>
            <description>Set the volume of the stream which range is [0, 1.0].</description>
        </method>

        <!--<method name="SetBalance">
            <arg type="d" name="balance" direction="in">
                <summary>The balance value.</summary>
            </arg>
            <description>Set the balance value which range is [-1, 1]. -1 represents that sound only on left speakers, right speakers silent and
            +1 represent that sound only on right speakers, left speakers silent.</description>
        </method>

        <method name="SetFade">
            <arg type="d" name="fade" direction="in">
                <summary>The fade value.</summary>
            </arg>
            <description>Set the fade value to balance between front and rear.</description>
        </method>-->

        <method name="SetMute">
            <arg type="b" name="mute" direction="in">
                <summary>The mute value.</summary>
            </arg>
            <description>Set the mute.</description>
        </method>

        <property name="index" type="u" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The stream index.</description>
        </property>

        <property name="name" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The stream name.</description>
        </property>

        <property name="mute" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The mute value.</description>
        </property>

        <property name="volume" type="d" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The volume value which range is [0, 1.0].</description>
        </property>

        <property name="application_name" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The application name.</description>
        </property>

        <property name="icon_name" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The icon name of the application.</description>
        </property>

        <!--<property name="balance" type="d" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The balance value.</description>
        </property>

        <property name="fade" type="d" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The fade value.</description>
        </property>-->

        <property name="state" type="u" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The Device supported items. Refer to struct PulseNodeState in audio-i.h file</description>
        </property>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/audio_stream_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::Audio::StreamStub::StreamStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Audio.Stream")
{
}

Kiran::SessionDaemon::Audio::StreamStub::~StreamStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::Audio::StreamStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &StreamStub::on_method_call),
            sigc::mem_fun(this, &StreamStub::on_interface_get_property),
            sigc::mem_fun(this, &StreamStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Audio.Stream"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::Audio::StreamStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::Audio::StreamStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("SetVolume") == 0) {
        Glib::Variant<double> base_volume;
        parameters.get_child(base_volume, 0);
        double p_volume = specialGetter(base_volume);

        MethodInvocation methodInvocation(invocation);
        SetVolume(
            (p_volume),
            methodInvocation);
    }

    if (method_name.compare("SetMute") == 0) {
        Glib::Variant<bool> base_mute;
        parameters.get_child(base_mute, 0);
        bool p_mute = specialGetter(base_mute);

        MethodInvocation methodInvocation(invocation);
        SetMute(
            (p_mute),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::Audio::StreamStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("index") == 0) {

        property = Glib::Variant<guint32>::create((index_get()));
    }

    if (property_name.compare("name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((name_get()));
    }

    if (property_name.compare("mute") == 0) {

        property = Glib::Variant<bool>::create((mute_get()));
    }

    if (property_name.compare("volume") == 0) {

        property = Glib::Variant<double>::create((volume_get()));
    }

    if (property_name.compare("application_name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((application_name_get()));
    }

    if (property_name.compare("icon_name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((icon_name_get()));
    }

    if (property_name.compare("state") == 0) {

        property = Glib::Variant<guint32>::create((state_get()));
    }

}

bool Kiran::SessionDaemon::Audio::StreamStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SessionDaemon::Audio::StreamStub::index_set(guint32 value)
{
    if (index_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((index_get()));

        emitSignal("index", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::name_set(const Glib::ustring & value)
{
    if (name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((name_get()));

        emitSignal("name", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::mute_set(bool value)
{
    if (mute_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((mute_get()));

        emitSignal("mute", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::volume_set(double value)
{
    if (volume_setHandler(value)) {
        Glib::Variant<double> value_get =
            Glib::Variant<double>::create((volume_get()));

        emitSignal("volume", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::application_name_set(const Glib::ustring & value)
{
    if (application_name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((application_name_get()));

        emitSignal("application_name", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::icon_name_set(const Glib::ustring & value)
{
    if (icon_name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((icon_name_get()));

        emitSignal("icon_name", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::state_set(guint32 value)
{
    if (state_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((state_get()));

        emitSignal("state", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Audio::StreamStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
