static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Bluetooth">

        <method name="GetAdapters">
            <arg type="as" name="adapters" direction="out">
                <doc:doc>
                    <doc:summary>The object path list.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Get the object paths for all the adapters.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="GetDevices">
            <arg type="o" name="adapter" direction="in">
                <doc:doc>
                    <doc:summary>The adapter object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="as" name="devices" direction="out">
                <doc:doc>
                    <doc:summary>The object path list.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Get devices for the specified adapter.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="FeedPinCode">
            <arg type="o" name="device" direction="in">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="b" name="accept" direction="in">
                <doc:doc>
                    <doc:summary>Whether to accept the pincode request.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="s" name="pincode" direction="in">
                <doc:doc>
                    <doc:summary>The accepted pincode.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Response the pincode request.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="FeedPasskey">
            <arg type="o" name="device" direction="in">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="b" name="accept" direction="in">
                <doc:doc>
                    <doc:summary>Whether to accept the passkey request.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="u" name="passkey" direction="in">
                <doc:doc>
                    <doc:summary>The accepted passkey.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Response the passkey request.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="Confirm">
            <arg type="o" name="device" direction="in">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="b" name="accept" direction="in">
                <doc:doc>
                    <doc:summary>Whether to accept the confirmation or authorization requests.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Response the confirmation or authorization requests.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <signal name="AdapterAdded">
            <arg name="adapter" type="o">
                <doc:doc>
                    <doc:summary>The adapter object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="AdapterRemoved">
            <arg name="adapter" type="o">
                <doc:doc>
                    <doc:summary>The adapter object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="DeviceAdded">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="DeviceRemove">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="RequestPinCode">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="DisplayPinCode">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg name="pincode" type="s">
                <doc:doc>
                    <doc:summary>The pincode.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="RequestPasskey">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="DisplayPasskey">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg name="passkey" type="u">
                <doc:doc>
                    <doc:summary>The passkey.</doc:summary>
                </doc:doc>
            </arg>
            <arg name="entered" type="q">
                <doc:doc>
                    <doc:summary>The number of already typed keys on the remote side.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="RequestConfirmation">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
            <arg name="passkey" type="u">
                <doc:doc>
                    <doc:summary>The passkey.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="RequestAuthorization">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="AuthorizeService">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>

            <arg name="uuid" type="s">
                <doc:doc>
                    <doc:summary>The device uuid.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

        <signal name="Cancel">
            <arg name="device" type="o">
                <doc:doc>
                    <doc:summary>The device object path.</doc:summary>
                </doc:doc>
            </arg>
        </signal>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluetooth_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::BluetoothStub::BluetoothStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Bluetooth")
{
    AdapterAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::AdapterAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    AdapterAdded_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::AdapterAdded_emitter));
    AdapterRemoved_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::AdapterRemoved_emitter),
            std::vector<Glib::ustring>({""})) );
    AdapterRemoved_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::AdapterRemoved_emitter));
    DeviceAdded_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::DeviceAdded_emitter),
            std::vector<Glib::ustring>({""})) );
    DeviceAdded_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::DeviceAdded_emitter));
    DeviceRemove_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::DeviceRemove_emitter),
            std::vector<Glib::ustring>({""})) );
    DeviceRemove_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::DeviceRemove_emitter));
    RequestPinCode_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::RequestPinCode_emitter),
            std::vector<Glib::ustring>({""})) );
    RequestPinCode_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::RequestPinCode_emitter));
    DisplayPinCode_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::DisplayPinCode_emitter),
            std::vector<Glib::ustring>({""})) );
    DisplayPinCode_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::DisplayPinCode_emitter));
    RequestPasskey_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::RequestPasskey_emitter),
            std::vector<Glib::ustring>({""})) );
    RequestPasskey_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::RequestPasskey_emitter));
    DisplayPasskey_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::DisplayPasskey_emitter),
            std::vector<Glib::ustring>({""})) );
    DisplayPasskey_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::DisplayPasskey_emitter));
    RequestConfirmation_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::RequestConfirmation_emitter),
            std::vector<Glib::ustring>({""})) );
    RequestConfirmation_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::RequestConfirmation_emitter));
    RequestAuthorization_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::RequestAuthorization_emitter),
            std::vector<Glib::ustring>({""})) );
    RequestAuthorization_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::RequestAuthorization_emitter));
    AuthorizeService_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::AuthorizeService_emitter),
            std::vector<Glib::ustring>({""})) );
    AuthorizeService_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::AuthorizeService_emitter));
    Cancel_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &BluetoothStub::Cancel_emitter),
            std::vector<Glib::ustring>({""})) );
    Cancel_selectiveSignal.connect(sigc::mem_fun(this, &BluetoothStub::Cancel_emitter));
}

Kiran::SessionDaemon::BluetoothStub::~BluetoothStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::BluetoothStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &BluetoothStub::on_method_call),
            sigc::mem_fun(this, &BluetoothStub::on_interface_get_property),
            sigc::mem_fun(this, &BluetoothStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Bluetooth"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::BluetoothStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::BluetoothStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("GetAdapters") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetAdapters(
            methodInvocation);
    }

    if (method_name.compare("GetDevices") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_adapter;
        parameters.get_child(base_adapter, 0);
        Glib::DBusObjectPathString p_adapter = specialGetter(base_adapter);

        MethodInvocation methodInvocation(invocation);
        GetDevices(
            (p_adapter),
            methodInvocation);
    }

    if (method_name.compare("FeedPinCode") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_device;
        parameters.get_child(base_device, 0);
        Glib::DBusObjectPathString p_device = specialGetter(base_device);

        Glib::Variant<bool> base_accept;
        parameters.get_child(base_accept, 1);
        bool p_accept = specialGetter(base_accept);

        Glib::Variant<Glib::ustring> base_pincode;
        parameters.get_child(base_pincode, 2);
        Glib::ustring p_pincode = specialGetter(base_pincode);

        MethodInvocation methodInvocation(invocation);
        FeedPinCode(
            (p_device),
            (p_accept),
            (p_pincode),
            methodInvocation);
    }

    if (method_name.compare("FeedPasskey") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_device;
        parameters.get_child(base_device, 0);
        Glib::DBusObjectPathString p_device = specialGetter(base_device);

        Glib::Variant<bool> base_accept;
        parameters.get_child(base_accept, 1);
        bool p_accept = specialGetter(base_accept);

        Glib::Variant<guint32> base_passkey;
        parameters.get_child(base_passkey, 2);
        guint32 p_passkey = specialGetter(base_passkey);

        MethodInvocation methodInvocation(invocation);
        FeedPasskey(
            (p_device),
            (p_accept),
            (p_passkey),
            methodInvocation);
    }

    if (method_name.compare("Confirm") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_device;
        parameters.get_child(base_device, 0);
        Glib::DBusObjectPathString p_device = specialGetter(base_device);

        Glib::Variant<bool> base_accept;
        parameters.get_child(base_accept, 1);
        bool p_accept = specialGetter(base_accept);

        MethodInvocation methodInvocation(invocation);
        Confirm(
            (p_device),
            (p_accept),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::BluetoothStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

}

bool Kiran::SessionDaemon::BluetoothStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}

void Kiran::SessionDaemon::BluetoothStub::AdapterAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & adapter)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((adapter)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "AdapterAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::AdapterRemoved_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & adapter)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((adapter)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "AdapterRemoved",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::DeviceAdded_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "DeviceAdded",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::DeviceRemove_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "DeviceRemove",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::RequestPinCode_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "RequestPinCode",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::DisplayPinCode_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device, const Glib::ustring & pincode)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;
    paramsList.push_back(Glib::Variant<Glib::ustring>::create((pincode)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "DisplayPinCode",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::RequestPasskey_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "RequestPasskey",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::DisplayPasskey_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device, guint32 passkey, guint16 entered)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;
    paramsList.push_back(Glib::Variant<guint32>::create((passkey)));;
    paramsList.push_back(Glib::Variant<guint16>::create((entered)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "DisplayPasskey",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::RequestConfirmation_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device, guint32 passkey)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;
    paramsList.push_back(Glib::Variant<guint32>::create((passkey)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "RequestConfirmation",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::RequestAuthorization_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "RequestAuthorization",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::AuthorizeService_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device, const Glib::ustring & uuid)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;
    paramsList.push_back(Glib::Variant<Glib::ustring>::create((uuid)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "AuthorizeService",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::BluetoothStub::Cancel_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::DBusObjectPathString & device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::DBusObjectPathString>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Bluetooth",
                    "Cancel",
                    bus_name,
                    params);
        }
    }
}


bool Kiran::SessionDaemon::BluetoothStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
