#pragma once
#include <iostream>
#include <vector>
#include "glibmm.h"
#include "giomm.h"

namespace bluez {

class Adapter1TypeWrap {
public:
    template<typename T>
    static void unwrapList(std::vector<T> &list, const Glib::VariantContainerBase &wrapped) {
        for (uint i = 0; i < wrapped.get_n_children(); i++) {
            Glib::Variant<T> item;
            wrapped.get_child(item, i);
            list.push_back(item.get());
        }
    }

    static std::vector<Glib::ustring> stdStringVecToGlibStringVec(const std::vector<std::string> &strv) {
        std::vector<Glib::ustring> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static std::vector<std::string> glibStringVecToStdStringVec(const std::vector<Glib::ustring> &strv) {
        std::vector<std::string> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static Glib::VariantContainerBase SetDiscoveryFilter_pack(
        const std::map<Glib::ustring,Glib::VariantBase> & arg_properties) {
        Glib::VariantContainerBase base;
        Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>> params =
            Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>>::create(arg_properties);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase RemoveDevice_pack(
        const Glib::DBusObjectPathString & arg_device) {
        Glib::VariantContainerBase base;
        Glib::VariantStringBase params;
        Glib::VariantStringBase::create_object_path(params, arg_device.c_str());
        return Glib::VariantContainerBase::create_tuple(params);
    }
};

} // bluez


