#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_adapter_dbus_common.h"

namespace bluez {

class Adapter1Proxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<Adapter1Proxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<Adapter1Proxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void StartDiscovery(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void StartDiscovery_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    StartDiscovery_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDiscoveryFilter(
        const std::map<Glib::ustring,Glib::VariantBase> & properties,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDiscoveryFilter_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetDiscoveryFilter_sync(
        const std::map<Glib::ustring,Glib::VariantBase> & properties,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void StopDiscovery(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void StopDiscovery_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    StopDiscovery_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RemoveDevice(
        const Glib::DBusObjectPathString & device,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RemoveDevice_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    RemoveDevice_sync(
        const Glib::DBusObjectPathString & device,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDiscoveryFilters(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDiscoveryFilters_finish (
        std::vector<Glib::ustring> &filters,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetDiscoveryFilters_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    Glib::ustring Address_get(bool *ok = nullptr);
    sigc::signal<void> &Address_changed() {
        return m_Address_changed;
    }

    Glib::ustring AddressType_get(bool *ok = nullptr);
    sigc::signal<void> &AddressType_changed() {
        return m_AddressType_changed;
    }

    Glib::ustring Name_get(bool *ok = nullptr);
    sigc::signal<void> &Name_changed() {
        return m_Name_changed;
    }

    Glib::ustring Alias_get(bool *ok = nullptr);
    void Alias_set(const Glib::ustring &, const Gio::SlotAsyncReady &);
    void Alias_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Alias_set_sync(const Glib::ustring &);
    sigc::signal<void> &Alias_changed() {
        return m_Alias_changed;
    }

    guint32 Class_get(bool *ok = nullptr);
    sigc::signal<void> &Class_changed() {
        return m_Class_changed;
    }

    bool Powered_get(bool *ok = nullptr);
    void Powered_set(bool, const Gio::SlotAsyncReady &);
    void Powered_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Powered_set_sync(bool);
    sigc::signal<void> &Powered_changed() {
        return m_Powered_changed;
    }

    bool Discoverable_get(bool *ok = nullptr);
    void Discoverable_set(bool, const Gio::SlotAsyncReady &);
    void Discoverable_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Discoverable_set_sync(bool);
    sigc::signal<void> &Discoverable_changed() {
        return m_Discoverable_changed;
    }

    guint32 DiscoverableTimeout_get(bool *ok = nullptr);
    void DiscoverableTimeout_set(guint32, const Gio::SlotAsyncReady &);
    void DiscoverableTimeout_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void DiscoverableTimeout_set_sync(guint32);
    sigc::signal<void> &DiscoverableTimeout_changed() {
        return m_DiscoverableTimeout_changed;
    }

    bool Pairable_get(bool *ok = nullptr);
    void Pairable_set(bool, const Gio::SlotAsyncReady &);
    void Pairable_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Pairable_set_sync(bool);
    sigc::signal<void> &Pairable_changed() {
        return m_Pairable_changed;
    }

    guint32 PairableTimeout_get(bool *ok = nullptr);
    void PairableTimeout_set(guint32, const Gio::SlotAsyncReady &);
    void PairableTimeout_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void PairableTimeout_set_sync(guint32);
    sigc::signal<void> &PairableTimeout_changed() {
        return m_PairableTimeout_changed;
    }

    bool Discovering_get(bool *ok = nullptr);
    sigc::signal<void> &Discovering_changed() {
        return m_Discovering_changed;
    }

    std::vector<Glib::ustring> UUIDs_get(bool *ok = nullptr);
    sigc::signal<void> &UUIDs_changed() {
        return m_UUIDs_changed;
    }

    Glib::ustring Modalias_get(bool *ok = nullptr);
    sigc::signal<void> &Modalias_changed() {
        return m_Modalias_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    Adapter1Proxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_Address_changed;
    sigc::signal<void> m_AddressType_changed;
    sigc::signal<void> m_Name_changed;
    sigc::signal<void> m_Alias_changed;
    sigc::signal<void> m_Class_changed;
    sigc::signal<void> m_Powered_changed;
    sigc::signal<void> m_Discoverable_changed;
    sigc::signal<void> m_DiscoverableTimeout_changed;
    sigc::signal<void> m_Pairable_changed;
    sigc::signal<void> m_PairableTimeout_changed;
    sigc::signal<void> m_Discovering_changed;
    sigc::signal<void> m_UUIDs_changed;
    sigc::signal<void> m_Modalias_changed;
};

}// bluez

