static const char interfaceXml0[] = R"XML_DELIMITER(<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="org.bluez.Adapter1">
        <method name="StartDiscovery"></method>
        <method name="SetDiscoveryFilter">
            <arg name="properties" type="a{sv}" direction="in"/>
        </method>
        <method name="StopDiscovery"></method>
        <method name="RemoveDevice">
            <arg name="device" type="o" direction="in"/>
        </method>
        <method name="GetDiscoveryFilters">
            <arg name="filters" type="as" direction="out"/>
        </method>
        <property name="Address" type="s" access="read"></property>
        <property name="AddressType" type="s" access="read"></property>
        <property name="Name" type="s" access="read"></property>
        <property name="Alias" type="s" access="readwrite"></property>
        <property name="Class" type="u" access="read"></property>
        <property name="Powered" type="b" access="readwrite"></property>
        <property name="Discoverable" type="b" access="readwrite"></property>
        <property name="DiscoverableTimeout" type="u" access="readwrite"></property>
        <property name="Pairable" type="b" access="readwrite"></property>
        <property name="PairableTimeout" type="u" access="readwrite"></property>
        <property name="Discovering" type="b" access="read"></property>
        <property name="UUIDs" type="as" access="read"></property>
        <property name="Modalias" type="s" access="read"></property>
    </interface>
    <!--<interface name="org.bluez.GattManager1">
        <method name="RegisterApplication">
            <arg name="application" type="o" direction="in"/>
            <arg name="options" type="a{sv}" direction="in"/>
        </method>
        <method name="UnregisterApplication">
            <arg name="application" type="o" direction="in"/>
        </method>
    </interface>
    <interface name="org.bluez.LEAdvertisingManager1">
        <method name="RegisterAdvertisement">
            <arg name="advertisement" type="o" direction="in"/>
            <arg name="options" type="a{sv}" direction="in"/>
        </method>
        <method name="UnregisterAdvertisement">
            <arg name="service" type="o" direction="in"/>
        </method>
        <property name="ActiveInstances" type="y" access="read"></property>
        <property name="SupportedInstances" type="y" access="read"></property>
        <property name="SupportedIncludes" type="as" access="read"></property>
    </interface>
    <interface name="org.bluez.Media1">
        <method name="RegisterEndpoint">
            <arg name="endpoint" type="o" direction="in"/>
            <arg name="properties" type="a{sv}" direction="in"/>
        </method>
        <method name="UnregisterEndpoint">
            <arg name="endpoint" type="o" direction="in"/>
        </method>
        <method name="RegisterPlayer">
            <arg name="player" type="o" direction="in"/>
            <arg name="properties" type="a{sv}" direction="in"/>
        </method>
        <method name="UnregisterPlayer">
            <arg name="player" type="o" direction="in"/>
        </method>
    </interface>
    <interface name="org.bluez.NetworkServer1">
        <method name="Register">
            <arg name="uuid" type="s" direction="in"/>
            <arg name="bridge" type="s" direction="in"/>
        </method>
        <method name="Unregister">
            <arg name="uuid" type="s" direction="in"/>
        </method>
    </interface>-->
</node>)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_adapter_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

bluez::Adapter1Stub::Adapter1Stub():
    m_interfaceName("org.bluez.Adapter1")
{
}

bluez::Adapter1Stub::~Adapter1Stub()
{
    unregister_object();
}

guint bluez::Adapter1Stub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &Adapter1Stub::on_method_call),
            sigc::mem_fun(this, &Adapter1Stub::on_interface_get_property),
            sigc::mem_fun(this, &Adapter1Stub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("org.bluez.Adapter1"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void bluez::Adapter1Stub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void bluez::Adapter1Stub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("StartDiscovery") == 0) {
        MethodInvocation methodInvocation(invocation);
        StartDiscovery(
            methodInvocation);
    }

    if (method_name.compare("SetDiscoveryFilter") == 0) {
        Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>> base_properties;
        parameters.get_child(base_properties, 0);
        std::map<Glib::ustring,Glib::VariantBase> p_properties = specialGetter(base_properties);

        MethodInvocation methodInvocation(invocation);
        SetDiscoveryFilter(
            (p_properties),
            methodInvocation);
    }

    if (method_name.compare("StopDiscovery") == 0) {
        MethodInvocation methodInvocation(invocation);
        StopDiscovery(
            methodInvocation);
    }

    if (method_name.compare("RemoveDevice") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_device;
        parameters.get_child(base_device, 0);
        Glib::DBusObjectPathString p_device = specialGetter(base_device);

        MethodInvocation methodInvocation(invocation);
        RemoveDevice(
            (p_device),
            methodInvocation);
    }

    if (method_name.compare("GetDiscoveryFilters") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetDiscoveryFilters(
            methodInvocation);
    }

}

void bluez::Adapter1Stub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("Address") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Address_get()));
    }

    if (property_name.compare("AddressType") == 0) {

        property = Glib::Variant<Glib::ustring>::create((AddressType_get()));
    }

    if (property_name.compare("Name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Name_get()));
    }

    if (property_name.compare("Alias") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Alias_get()));
    }

    if (property_name.compare("Class") == 0) {

        property = Glib::Variant<guint32>::create((Class_get()));
    }

    if (property_name.compare("Powered") == 0) {

        property = Glib::Variant<bool>::create((Powered_get()));
    }

    if (property_name.compare("Discoverable") == 0) {

        property = Glib::Variant<bool>::create((Discoverable_get()));
    }

    if (property_name.compare("DiscoverableTimeout") == 0) {

        property = Glib::Variant<guint32>::create((DiscoverableTimeout_get()));
    }

    if (property_name.compare("Pairable") == 0) {

        property = Glib::Variant<bool>::create((Pairable_get()));
    }

    if (property_name.compare("PairableTimeout") == 0) {

        property = Glib::Variant<guint32>::create((PairableTimeout_get()));
    }

    if (property_name.compare("Discovering") == 0) {

        property = Glib::Variant<bool>::create((Discovering_get()));
    }

    if (property_name.compare("UUIDs") == 0) {

        property = Glib::Variant<std::vector<Glib::ustring>>::create((UUIDs_get()));
    }

    if (property_name.compare("Modalias") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Modalias_get()));
    }

}

bool bluez::Adapter1Stub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    if (property_name.compare("Alias") == 0) {
        try {
            Glib::Variant<Glib::ustring> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<Glib::ustring>>(value);
            Glib::ustring val =
                (specialGetter(castValue));
            Alias_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Alias");
        }
    }

    if (property_name.compare("Powered") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            Powered_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Powered");
        }
    }

    if (property_name.compare("Discoverable") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            Discoverable_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Discoverable");
        }
    }

    if (property_name.compare("DiscoverableTimeout") == 0) {
        try {
            Glib::Variant<guint32> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<guint32>>(value);
            guint32 val =
                (specialGetter(castValue));
            DiscoverableTimeout_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting DiscoverableTimeout");
        }
    }

    if (property_name.compare("Pairable") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            Pairable_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Pairable");
        }
    }

    if (property_name.compare("PairableTimeout") == 0) {
        try {
            Glib::Variant<guint32> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<guint32>>(value);
            guint32 val =
                (specialGetter(castValue));
            PairableTimeout_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting PairableTimeout");
        }
    }

    return true;
}


bool bluez::Adapter1Stub::Address_set(const Glib::ustring & value)
{
    if (Address_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Address_get()));

        emitSignal("Address", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::AddressType_set(const Glib::ustring & value)
{
    if (AddressType_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((AddressType_get()));

        emitSignal("AddressType", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Name_set(const Glib::ustring & value)
{
    if (Name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Name_get()));

        emitSignal("Name", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Alias_set(const Glib::ustring & value)
{
    if (Alias_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Alias_get()));

        emitSignal("Alias", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Class_set(guint32 value)
{
    if (Class_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((Class_get()));

        emitSignal("Class", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Powered_set(bool value)
{
    if (Powered_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Powered_get()));

        emitSignal("Powered", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Discoverable_set(bool value)
{
    if (Discoverable_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Discoverable_get()));

        emitSignal("Discoverable", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::DiscoverableTimeout_set(guint32 value)
{
    if (DiscoverableTimeout_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((DiscoverableTimeout_get()));

        emitSignal("DiscoverableTimeout", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Pairable_set(bool value)
{
    if (Pairable_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Pairable_get()));

        emitSignal("Pairable", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::PairableTimeout_set(guint32 value)
{
    if (PairableTimeout_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((PairableTimeout_get()));

        emitSignal("PairableTimeout", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Discovering_set(bool value)
{
    if (Discovering_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Discovering_get()));

        emitSignal("Discovering", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::UUIDs_set(const std::vector<Glib::ustring> & value)
{
    if (UUIDs_setHandler(value)) {
        Glib::Variant<std::vector<Glib::ustring>> value_get =
            Glib::Variant<std::vector<Glib::ustring>>::create((UUIDs_get()));

        emitSignal("UUIDs", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::Modalias_set(const Glib::ustring & value)
{
    if (Modalias_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Modalias_get()));

        emitSignal("Modalias", value_get);
        return true;
    }

    return false;
}

bool bluez::Adapter1Stub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
