#pragma once
#include <string>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_adapter_dbus_common.h"

namespace bluez {

class Adapter1Stub : public sigc::trackable {
public:
    Adapter1Stub();
    virtual ~Adapter1Stub();

    Adapter1Stub(const Adapter1Stub &other) = delete;
    Adapter1Stub(Adapter1Stub &&other) = delete;
    Adapter1Stub &operator=(const Adapter1Stub &other) = delete;
    Adapter1Stub &operator=(Adapter1Stub &&other) = delete;

    guint register_object(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                          const Glib::ustring &object_path);
    void unregister_object();

    unsigned int usage_count() const {
        return static_cast<unsigned int>(m_registered_objects.size());
    }

    class MethodInvocation;

    bool Address_set(const Glib::ustring & value);
    bool AddressType_set(const Glib::ustring & value);
    bool Name_set(const Glib::ustring & value);
    bool Alias_set(const Glib::ustring & value);
    bool Class_set(guint32 value);
    bool Powered_set(bool value);
    bool Discoverable_set(bool value);
    bool DiscoverableTimeout_set(guint32 value);
    bool Pairable_set(bool value);
    bool PairableTimeout_set(guint32 value);
    bool Discovering_set(bool value);
    bool UUIDs_set(const std::vector<Glib::ustring> & value);
    bool Modalias_set(const Glib::ustring & value);
protected:
    virtual void StartDiscovery(
        MethodInvocation &invocation) = 0;
    virtual void SetDiscoveryFilter(
        const std::map<Glib::ustring,Glib::VariantBase> & properties,
        MethodInvocation &invocation) = 0;
    virtual void StopDiscovery(
        MethodInvocation &invocation) = 0;
    virtual void RemoveDevice(
        const Glib::DBusObjectPathString & device,
        MethodInvocation &invocation) = 0;
    virtual void GetDiscoveryFilters(
        MethodInvocation &invocation) = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Address_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Address_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool AddressType_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring AddressType_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Name_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Name_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Alias_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Alias_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Class_setHandler(guint32 value) = 0;
    virtual guint32 Class_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Powered_setHandler(bool value) = 0;
    virtual bool Powered_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Discoverable_setHandler(bool value) = 0;
    virtual bool Discoverable_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool DiscoverableTimeout_setHandler(guint32 value) = 0;
    virtual guint32 DiscoverableTimeout_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Pairable_setHandler(bool value) = 0;
    virtual bool Pairable_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool PairableTimeout_setHandler(guint32 value) = 0;
    virtual guint32 PairableTimeout_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Discovering_setHandler(bool value) = 0;
    virtual bool Discovering_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool UUIDs_setHandler(const std::vector<Glib::ustring> & value) = 0;
    virtual std::vector<Glib::ustring> UUIDs_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Modalias_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Modalias_get() = 0;

    void on_method_call(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                        const Glib::ustring &sender,
                        const Glib::ustring &object_path,
                        const Glib::ustring &interface_name,
                        const Glib::ustring &method_name,
                        const Glib::VariantContainerBase &parameters,
                        const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation);

    void on_interface_get_property(Glib::VariantBase& property,
                                   const Glib::RefPtr<Gio::DBus::Connection> &connection,
                                   const Glib::ustring &sender,
                                   const Glib::ustring &object_path,
                                   const Glib::ustring &interface_name,
                                   const Glib::ustring &property_name);

    bool on_interface_set_property(
        const Glib::RefPtr<Gio::DBus::Connection> &connection,
        const Glib::ustring &sender,
        const Glib::ustring &object_path,
        const Glib::ustring &interface_name,
        const Glib::ustring &property_name,
        const Glib::VariantBase &value);

private:
    bool emitSignal(const std::string &propName, Glib::VariantBase &value);

    struct RegisteredObject {
        guint id;
        Glib::RefPtr<Gio::DBus::Connection> connection;
        std::string object_path;
    };

    Glib::RefPtr<Gio::DBus::NodeInfo> introspection_data;
    std::vector<RegisteredObject> m_registered_objects;
    std::string m_interfaceName;
};

class Adapter1Stub::MethodInvocation {
public:
    MethodInvocation(const Glib::RefPtr<Gio::DBus::MethodInvocation> &msg):
        m_message(msg) {}

    const Glib::RefPtr<Gio::DBus::MethodInvocation> getMessage() {
        return m_message;
    }

    void ret(Glib::Error error) {
        m_message->return_error(error);
    }

    void returnError(const Glib::ustring &domain, int code, const Glib::ustring &message) {
        m_message->return_error(domain, code, message);
    }

    void ret() {
        std::vector<Glib::VariantBase> vlist;

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(const std::vector<Glib::ustring> & p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<std::vector<Glib::ustring>> var0 =
            Glib::Variant<std::vector<Glib::ustring>>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

private:
    Glib::RefPtr<Gio::DBus::MethodInvocation> m_message;
};

} // bluez

