#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_agent_dbus_common.h"

namespace bluez {

class Agent1Proxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<Agent1Proxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<Agent1Proxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void Release(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Release_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Release_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestPinCode(
        const Glib::DBusObjectPathString & device,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestPinCode_finish (
        Glib::ustring &pincode,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    RequestPinCode_sync(
        const Glib::DBusObjectPathString & device,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisplayPinCode(
        const Glib::DBusObjectPathString & device,
        const Glib::ustring & pincode,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisplayPinCode_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DisplayPinCode_sync(
        const Glib::DBusObjectPathString & device,        const Glib::ustring & pincode,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestPasskey(
        const Glib::DBusObjectPathString & device,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestPasskey_finish (
        guint32 &passkey,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    guint32
    RequestPasskey_sync(
        const Glib::DBusObjectPathString & device,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisplayPasskey(
        const Glib::DBusObjectPathString & device,
        guint32 passkey,
        guint16 entered,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisplayPasskey_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DisplayPasskey_sync(
        const Glib::DBusObjectPathString & device,        guint32 passkey,        guint16 entered,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestConfirmation(
        const Glib::DBusObjectPathString & device,
        guint32 passkey,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestConfirmation_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    RequestConfirmation_sync(
        const Glib::DBusObjectPathString & device,        guint32 passkey,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestAuthorization(
        const Glib::DBusObjectPathString & device,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void RequestAuthorization_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    RequestAuthorization_sync(
        const Glib::DBusObjectPathString & device,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AuthorizeService(
        const Glib::DBusObjectPathString & device,
        const Glib::ustring & uuid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AuthorizeService_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    AuthorizeService_sync(
        const Glib::DBusObjectPathString & device,        const Glib::ustring & uuid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Cancel(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Cancel_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Cancel_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    Agent1Proxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

};

}// bluez

