#pragma once
#include <string>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_agent_dbus_common.h"

namespace bluez {

class Agent1Stub : public sigc::trackable {
public:
    Agent1Stub();
    virtual ~Agent1Stub();

    Agent1Stub(const Agent1Stub &other) = delete;
    Agent1Stub(Agent1Stub &&other) = delete;
    Agent1Stub &operator=(const Agent1Stub &other) = delete;
    Agent1Stub &operator=(Agent1Stub &&other) = delete;

    guint register_object(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                          const Glib::ustring &object_path);
    void unregister_object();

    unsigned int usage_count() const {
        return static_cast<unsigned int>(m_registered_objects.size());
    }

    class MethodInvocation;

protected:
    virtual void Release(
        MethodInvocation &invocation) = 0;
    virtual void RequestPinCode(
        const Glib::DBusObjectPathString & device,
        MethodInvocation &invocation) = 0;
    virtual void DisplayPinCode(
        const Glib::DBusObjectPathString & device,
        const Glib::ustring & pincode,
        MethodInvocation &invocation) = 0;
    virtual void RequestPasskey(
        const Glib::DBusObjectPathString & device,
        MethodInvocation &invocation) = 0;
    virtual void DisplayPasskey(
        const Glib::DBusObjectPathString & device,
        guint32 passkey,
        guint16 entered,
        MethodInvocation &invocation) = 0;
    virtual void RequestConfirmation(
        const Glib::DBusObjectPathString & device,
        guint32 passkey,
        MethodInvocation &invocation) = 0;
    virtual void RequestAuthorization(
        const Glib::DBusObjectPathString & device,
        MethodInvocation &invocation) = 0;
    virtual void AuthorizeService(
        const Glib::DBusObjectPathString & device,
        const Glib::ustring & uuid,
        MethodInvocation &invocation) = 0;
    virtual void Cancel(
        MethodInvocation &invocation) = 0;

    void on_method_call(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                        const Glib::ustring &sender,
                        const Glib::ustring &object_path,
                        const Glib::ustring &interface_name,
                        const Glib::ustring &method_name,
                        const Glib::VariantContainerBase &parameters,
                        const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation);

    void on_interface_get_property(Glib::VariantBase& property,
                                   const Glib::RefPtr<Gio::DBus::Connection> &connection,
                                   const Glib::ustring &sender,
                                   const Glib::ustring &object_path,
                                   const Glib::ustring &interface_name,
                                   const Glib::ustring &property_name);

    bool on_interface_set_property(
        const Glib::RefPtr<Gio::DBus::Connection> &connection,
        const Glib::ustring &sender,
        const Glib::ustring &object_path,
        const Glib::ustring &interface_name,
        const Glib::ustring &property_name,
        const Glib::VariantBase &value);

private:
    bool emitSignal(const std::string &propName, Glib::VariantBase &value);

    struct RegisteredObject {
        guint id;
        Glib::RefPtr<Gio::DBus::Connection> connection;
        std::string object_path;
    };

    Glib::RefPtr<Gio::DBus::NodeInfo> introspection_data;
    std::vector<RegisteredObject> m_registered_objects;
    std::string m_interfaceName;
};

class Agent1Stub::MethodInvocation {
public:
    MethodInvocation(const Glib::RefPtr<Gio::DBus::MethodInvocation> &msg):
        m_message(msg) {}

    const Glib::RefPtr<Gio::DBus::MethodInvocation> getMessage() {
        return m_message;
    }

    void ret(Glib::Error error) {
        m_message->return_error(error);
    }

    void returnError(const Glib::ustring &domain, int code, const Glib::ustring &message) {
        m_message->return_error(domain, code, message);
    }

    void ret() {
        std::vector<Glib::VariantBase> vlist;

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(const Glib::ustring & p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<Glib::ustring> var0 =
            Glib::Variant<Glib::ustring>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

    void ret(guint32 p0) {
        std::vector<Glib::VariantBase> vlist;
        Glib::Variant<guint32> var0 =
            Glib::Variant<guint32>::create(p0);
        vlist.push_back(var0);

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

private:
    Glib::RefPtr<Gio::DBus::MethodInvocation> m_message;
};

} // bluez

