#pragma once
#include <iostream>
#include <vector>
#include "glibmm.h"
#include "giomm.h"

namespace bluez {

class AgentManager1TypeWrap {
public:
    template<typename T>
    static void unwrapList(std::vector<T> &list, const Glib::VariantContainerBase &wrapped) {
        for (uint i = 0; i < wrapped.get_n_children(); i++) {
            Glib::Variant<T> item;
            wrapped.get_child(item, i);
            list.push_back(item.get());
        }
    }

    static std::vector<Glib::ustring> stdStringVecToGlibStringVec(const std::vector<std::string> &strv) {
        std::vector<Glib::ustring> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static std::vector<std::string> glibStringVecToStdStringVec(const std::vector<Glib::ustring> &strv) {
        std::vector<std::string> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static Glib::VariantContainerBase RegisterAgent_pack(
        const Glib::DBusObjectPathString & arg_agent,
        const Glib::ustring & arg_capability) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::VariantStringBase agent_param;
        Glib::VariantStringBase::create_object_path(agent_param, arg_agent.c_str());
        params.push_back(agent_param);

        Glib::Variant<Glib::ustring> capability_param =
            Glib::Variant<Glib::ustring>::create(arg_capability);
        params.push_back(capability_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase UnregisterAgent_pack(
        const Glib::DBusObjectPathString & arg_agent) {
        Glib::VariantContainerBase base;
        Glib::VariantStringBase params;
        Glib::VariantStringBase::create_object_path(params, arg_agent.c_str());
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase RequestDefaultAgent_pack(
        const Glib::DBusObjectPathString & arg_agent) {
        Glib::VariantContainerBase base;
        Glib::VariantStringBase params;
        Glib::VariantStringBase::create_object_path(params, arg_agent.c_str());
        return Glib::VariantContainerBase::create_tuple(params);
    }
};

} // bluez


