static const char interfaceXml0[] = R"XML_DELIMITER(<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="org.bluez.AgentManager1">
        <method name="RegisterAgent">
            <arg name="agent" type="o" direction="in"/>
            <arg name="capability" type="s" direction="in"/>
        </method>
        <method name="UnregisterAgent">
            <arg name="agent" type="o" direction="in"/>
        </method>
        <method name="RequestDefaultAgent">
            <arg name="agent" type="o" direction="in"/>
        </method>
    </interface>
    <!--<interface name="org.bluez.ProfileManager1">
        <method name="RegisterProfile">
            <arg name="profile" type="o" direction="in"/>
            <arg name="UUID" type="s" direction="in"/>
            <arg name="options" type="a{sv}" direction="in"/>
        </method>
        <method name="UnregisterProfile">
            <arg name="profile" type="o" direction="in"/>
        </method>
    </interface>-->
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_agent_manager_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

bluez::AgentManager1Stub::AgentManager1Stub():
    m_interfaceName("org.bluez.AgentManager1")
{
}

bluez::AgentManager1Stub::~AgentManager1Stub()
{
    unregister_object();
}

guint bluez::AgentManager1Stub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &AgentManager1Stub::on_method_call),
            sigc::mem_fun(this, &AgentManager1Stub::on_interface_get_property),
            sigc::mem_fun(this, &AgentManager1Stub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("org.bluez.AgentManager1"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void bluez::AgentManager1Stub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void bluez::AgentManager1Stub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("RegisterAgent") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_agent;
        parameters.get_child(base_agent, 0);
        Glib::DBusObjectPathString p_agent = specialGetter(base_agent);

        Glib::Variant<Glib::ustring> base_capability;
        parameters.get_child(base_capability, 1);
        Glib::ustring p_capability = specialGetter(base_capability);

        MethodInvocation methodInvocation(invocation);
        RegisterAgent(
            (p_agent),
            (p_capability),
            methodInvocation);
    }

    if (method_name.compare("UnregisterAgent") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_agent;
        parameters.get_child(base_agent, 0);
        Glib::DBusObjectPathString p_agent = specialGetter(base_agent);

        MethodInvocation methodInvocation(invocation);
        UnregisterAgent(
            (p_agent),
            methodInvocation);
    }

    if (method_name.compare("RequestDefaultAgent") == 0) {
        Glib::Variant<Glib::DBusObjectPathString> base_agent;
        parameters.get_child(base_agent, 0);
        Glib::DBusObjectPathString p_agent = specialGetter(base_agent);

        MethodInvocation methodInvocation(invocation);
        RequestDefaultAgent(
            (p_agent),
            methodInvocation);
    }

}

void bluez::AgentManager1Stub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

}

bool bluez::AgentManager1Stub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool bluez::AgentManager1Stub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
