#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_device_dbus_common.h"

namespace bluez {

class Device1Proxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<Device1Proxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<Device1Proxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void Disconnect(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Disconnect_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Disconnect_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Connect(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Connect_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Connect_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ConnectProfile(
        const Glib::ustring & UUID,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ConnectProfile_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    ConnectProfile_sync(
        const Glib::ustring & UUID,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisconnectProfile(
        const Glib::ustring & UUID,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DisconnectProfile_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DisconnectProfile_sync(
        const Glib::ustring & UUID,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Pair(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Pair_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Pair_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CancelPairing(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void CancelPairing_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    CancelPairing_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    Glib::ustring Address_get(bool *ok = nullptr);
    sigc::signal<void> &Address_changed() {
        return m_Address_changed;
    }

    Glib::ustring AddressType_get(bool *ok = nullptr);
    sigc::signal<void> &AddressType_changed() {
        return m_AddressType_changed;
    }

    Glib::ustring Name_get(bool *ok = nullptr);
    sigc::signal<void> &Name_changed() {
        return m_Name_changed;
    }

    Glib::ustring Alias_get(bool *ok = nullptr);
    void Alias_set(const Glib::ustring &, const Gio::SlotAsyncReady &);
    void Alias_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Alias_set_sync(const Glib::ustring &);
    sigc::signal<void> &Alias_changed() {
        return m_Alias_changed;
    }

    guint32 Class_get(bool *ok = nullptr);
    sigc::signal<void> &Class_changed() {
        return m_Class_changed;
    }

    guint16 Appearance_get(bool *ok = nullptr);
    sigc::signal<void> &Appearance_changed() {
        return m_Appearance_changed;
    }

    Glib::ustring Icon_get(bool *ok = nullptr);
    sigc::signal<void> &Icon_changed() {
        return m_Icon_changed;
    }

    bool Paired_get(bool *ok = nullptr);
    sigc::signal<void> &Paired_changed() {
        return m_Paired_changed;
    }

    bool Trusted_get(bool *ok = nullptr);
    void Trusted_set(bool, const Gio::SlotAsyncReady &);
    void Trusted_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Trusted_set_sync(bool);
    sigc::signal<void> &Trusted_changed() {
        return m_Trusted_changed;
    }

    bool Blocked_get(bool *ok = nullptr);
    void Blocked_set(bool, const Gio::SlotAsyncReady &);
    void Blocked_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void Blocked_set_sync(bool);
    sigc::signal<void> &Blocked_changed() {
        return m_Blocked_changed;
    }

    bool LegacyPairing_get(bool *ok = nullptr);
    sigc::signal<void> &LegacyPairing_changed() {
        return m_LegacyPairing_changed;
    }

    gint16 RSSI_get(bool *ok = nullptr);
    sigc::signal<void> &RSSI_changed() {
        return m_RSSI_changed;
    }

    bool Connected_get(bool *ok = nullptr);
    sigc::signal<void> &Connected_changed() {
        return m_Connected_changed;
    }

    std::vector<Glib::ustring> UUIDs_get(bool *ok = nullptr);
    sigc::signal<void> &UUIDs_changed() {
        return m_UUIDs_changed;
    }

    Glib::ustring Modalias_get(bool *ok = nullptr);
    sigc::signal<void> &Modalias_changed() {
        return m_Modalias_changed;
    }

    Glib::DBusObjectPathString Adapter_get(bool *ok = nullptr);
    sigc::signal<void> &Adapter_changed() {
        return m_Adapter_changed;
    }

    std::map<guint16,Glib::VariantBase> ManufacturerData_get(bool *ok = nullptr);
    sigc::signal<void> &ManufacturerData_changed() {
        return m_ManufacturerData_changed;
    }

    std::map<Glib::ustring,Glib::VariantBase> ServiceData_get(bool *ok = nullptr);
    sigc::signal<void> &ServiceData_changed() {
        return m_ServiceData_changed;
    }

    gint16 TxPower_get(bool *ok = nullptr);
    sigc::signal<void> &TxPower_changed() {
        return m_TxPower_changed;
    }

    bool ServicesResolved_get(bool *ok = nullptr);
    sigc::signal<void> &ServicesResolved_changed() {
        return m_ServicesResolved_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    Device1Proxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_Address_changed;
    sigc::signal<void> m_AddressType_changed;
    sigc::signal<void> m_Name_changed;
    sigc::signal<void> m_Alias_changed;
    sigc::signal<void> m_Class_changed;
    sigc::signal<void> m_Appearance_changed;
    sigc::signal<void> m_Icon_changed;
    sigc::signal<void> m_Paired_changed;
    sigc::signal<void> m_Trusted_changed;
    sigc::signal<void> m_Blocked_changed;
    sigc::signal<void> m_LegacyPairing_changed;
    sigc::signal<void> m_RSSI_changed;
    sigc::signal<void> m_Connected_changed;
    sigc::signal<void> m_UUIDs_changed;
    sigc::signal<void> m_Modalias_changed;
    sigc::signal<void> m_Adapter_changed;
    sigc::signal<void> m_ManufacturerData_changed;
    sigc::signal<void> m_ServiceData_changed;
    sigc::signal<void> m_TxPower_changed;
    sigc::signal<void> m_ServicesResolved_changed;
};

}// bluez

