static const char interfaceXml0[] = R"XML_DELIMITER(<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="org.bluez.Device1">
        <method name="Disconnect"></method>
        <method name="Connect"></method>
        <method name="ConnectProfile">
            <arg name="UUID" type="s" direction="in"/>
        </method>
        <method name="DisconnectProfile">
            <arg name="UUID" type="s" direction="in"/>
        </method>
        <method name="Pair"></method>
        <method name="CancelPairing"></method>
        <property name="Address" type="s" access="read"></property>
        <property name="AddressType" type="s" access="read"></property>
        <property name="Name" type="s" access="read"></property>
        <property name="Alias" type="s" access="readwrite"></property>
        <property name="Class" type="u" access="read"></property>
        <property name="Appearance" type="q" access="read"></property>
        <property name="Icon" type="s" access="read"></property>
        <property name="Paired" type="b" access="read"></property>
        <property name="Trusted" type="b" access="readwrite"></property>
        <property name="Blocked" type="b" access="readwrite"></property>
        <property name="LegacyPairing" type="b" access="read"></property>
        <property name="RSSI" type="n" access="read"></property>
        <property name="Connected" type="b" access="read"></property>
        <property name="UUIDs" type="as" access="read"></property>
        <property name="Modalias" type="s" access="read"></property>
        <property name="Adapter" type="o" access="read"></property>
        <property name="ManufacturerData" type="a{qv}" access="read"></property>
        <property name="ServiceData" type="a{sv}" access="read"></property>
        <property name="TxPower" type="n" access="read"></property>
        <property name="ServicesResolved" type="b" access="read"></property>
    </interface>

    <!--<interface name="org.bluez.Network1">
        <method name="Connect">
            <arg name="uuid" type="s" direction="in"/>
            <arg name="interface" type="s" direction="out"/>
        </method>
        <method name="Disconnect"></method>
        <property name="Connected" type="b" access="read"></property>
        <property name="Interface" type="s" access="read"></property>
        <property name="UUID" type="s" access="read"></property>
    </interface>
    <interface name="org.bluez.MediaControl1">
        <method name="Play">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="Pause">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="Stop">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="Next">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="Previous">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="VolumeUp">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="VolumeDown">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="FastForward">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <method name="Rewind">
            <annotation name="org.freedesktop.DBus.Deprecated" value="true"/>
        </method>
        <property name="Connected" type="b" access="read"></property>
        <property name="Player" type="o" access="read"></property>
    </interface>-->
</node>)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_device_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

bluez::Device1Stub::Device1Stub():
    m_interfaceName("org.bluez.Device1")
{
}

bluez::Device1Stub::~Device1Stub()
{
    unregister_object();
}

guint bluez::Device1Stub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &Device1Stub::on_method_call),
            sigc::mem_fun(this, &Device1Stub::on_interface_get_property),
            sigc::mem_fun(this, &Device1Stub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("org.bluez.Device1"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void bluez::Device1Stub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void bluez::Device1Stub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("Disconnect") == 0) {
        MethodInvocation methodInvocation(invocation);
        Disconnect(
            methodInvocation);
    }

    if (method_name.compare("Connect") == 0) {
        MethodInvocation methodInvocation(invocation);
        Connect(
            methodInvocation);
    }

    if (method_name.compare("ConnectProfile") == 0) {
        Glib::Variant<Glib::ustring> base_UUID;
        parameters.get_child(base_UUID, 0);
        Glib::ustring p_UUID = specialGetter(base_UUID);

        MethodInvocation methodInvocation(invocation);
        ConnectProfile(
            (p_UUID),
            methodInvocation);
    }

    if (method_name.compare("DisconnectProfile") == 0) {
        Glib::Variant<Glib::ustring> base_UUID;
        parameters.get_child(base_UUID, 0);
        Glib::ustring p_UUID = specialGetter(base_UUID);

        MethodInvocation methodInvocation(invocation);
        DisconnectProfile(
            (p_UUID),
            methodInvocation);
    }

    if (method_name.compare("Pair") == 0) {
        MethodInvocation methodInvocation(invocation);
        Pair(
            methodInvocation);
    }

    if (method_name.compare("CancelPairing") == 0) {
        MethodInvocation methodInvocation(invocation);
        CancelPairing(
            methodInvocation);
    }

}

void bluez::Device1Stub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("Address") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Address_get()));
    }

    if (property_name.compare("AddressType") == 0) {

        property = Glib::Variant<Glib::ustring>::create((AddressType_get()));
    }

    if (property_name.compare("Name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Name_get()));
    }

    if (property_name.compare("Alias") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Alias_get()));
    }

    if (property_name.compare("Class") == 0) {

        property = Glib::Variant<guint32>::create((Class_get()));
    }

    if (property_name.compare("Appearance") == 0) {

        property = Glib::Variant<guint16>::create((Appearance_get()));
    }

    if (property_name.compare("Icon") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Icon_get()));
    }

    if (property_name.compare("Paired") == 0) {

        property = Glib::Variant<bool>::create((Paired_get()));
    }

    if (property_name.compare("Trusted") == 0) {

        property = Glib::Variant<bool>::create((Trusted_get()));
    }

    if (property_name.compare("Blocked") == 0) {

        property = Glib::Variant<bool>::create((Blocked_get()));
    }

    if (property_name.compare("LegacyPairing") == 0) {

        property = Glib::Variant<bool>::create((LegacyPairing_get()));
    }

    if (property_name.compare("RSSI") == 0) {

        property = Glib::Variant<gint16>::create((RSSI_get()));
    }

    if (property_name.compare("Connected") == 0) {

        property = Glib::Variant<bool>::create((Connected_get()));
    }

    if (property_name.compare("UUIDs") == 0) {

        property = Glib::Variant<std::vector<Glib::ustring>>::create((UUIDs_get()));
    }

    if (property_name.compare("Modalias") == 0) {

        property = Glib::Variant<Glib::ustring>::create((Modalias_get()));
    }

    if (property_name.compare("Adapter") == 0) {

        property = Glib::Variant<Glib::DBusObjectPathString>::create((Adapter_get()));
    }

    if (property_name.compare("ManufacturerData") == 0) {

        property = Glib::Variant<std::map<guint16,Glib::VariantBase>>::create((ManufacturerData_get()));
    }

    if (property_name.compare("ServiceData") == 0) {

        property = Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>>::create((ServiceData_get()));
    }

    if (property_name.compare("TxPower") == 0) {

        property = Glib::Variant<gint16>::create((TxPower_get()));
    }

    if (property_name.compare("ServicesResolved") == 0) {

        property = Glib::Variant<bool>::create((ServicesResolved_get()));
    }

}

bool bluez::Device1Stub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    if (property_name.compare("Alias") == 0) {
        try {
            Glib::Variant<Glib::ustring> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<Glib::ustring>>(value);
            Glib::ustring val =
                (specialGetter(castValue));
            Alias_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Alias");
        }
    }

    if (property_name.compare("Trusted") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            Trusted_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Trusted");
        }
    }

    if (property_name.compare("Blocked") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            Blocked_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting Blocked");
        }
    }

    return true;
}


bool bluez::Device1Stub::Address_set(const Glib::ustring & value)
{
    if (Address_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Address_get()));

        emitSignal("Address", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::AddressType_set(const Glib::ustring & value)
{
    if (AddressType_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((AddressType_get()));

        emitSignal("AddressType", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Name_set(const Glib::ustring & value)
{
    if (Name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Name_get()));

        emitSignal("Name", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Alias_set(const Glib::ustring & value)
{
    if (Alias_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Alias_get()));

        emitSignal("Alias", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Class_set(guint32 value)
{
    if (Class_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((Class_get()));

        emitSignal("Class", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Appearance_set(guint16 value)
{
    if (Appearance_setHandler(value)) {
        Glib::Variant<guint16> value_get =
            Glib::Variant<guint16>::create((Appearance_get()));

        emitSignal("Appearance", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Icon_set(const Glib::ustring & value)
{
    if (Icon_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Icon_get()));

        emitSignal("Icon", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Paired_set(bool value)
{
    if (Paired_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Paired_get()));

        emitSignal("Paired", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Trusted_set(bool value)
{
    if (Trusted_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Trusted_get()));

        emitSignal("Trusted", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Blocked_set(bool value)
{
    if (Blocked_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Blocked_get()));

        emitSignal("Blocked", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::LegacyPairing_set(bool value)
{
    if (LegacyPairing_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((LegacyPairing_get()));

        emitSignal("LegacyPairing", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::RSSI_set(gint16 value)
{
    if (RSSI_setHandler(value)) {
        Glib::Variant<gint16> value_get =
            Glib::Variant<gint16>::create((RSSI_get()));

        emitSignal("RSSI", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Connected_set(bool value)
{
    if (Connected_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((Connected_get()));

        emitSignal("Connected", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::UUIDs_set(const std::vector<Glib::ustring> & value)
{
    if (UUIDs_setHandler(value)) {
        Glib::Variant<std::vector<Glib::ustring>> value_get =
            Glib::Variant<std::vector<Glib::ustring>>::create((UUIDs_get()));

        emitSignal("UUIDs", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Modalias_set(const Glib::ustring & value)
{
    if (Modalias_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((Modalias_get()));

        emitSignal("Modalias", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::Adapter_set(const Glib::DBusObjectPathString & value)
{
    if (Adapter_setHandler(value)) {
        Glib::Variant<Glib::DBusObjectPathString> value_get =
            Glib::Variant<Glib::DBusObjectPathString>::create((Adapter_get()));

        emitSignal("Adapter", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::ManufacturerData_set(const std::map<guint16,Glib::VariantBase> & value)
{
    if (ManufacturerData_setHandler(value)) {
        Glib::Variant<std::map<guint16,Glib::VariantBase>> value_get =
            Glib::Variant<std::map<guint16,Glib::VariantBase>>::create((ManufacturerData_get()));

        emitSignal("ManufacturerData", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::ServiceData_set(const std::map<Glib::ustring,Glib::VariantBase> & value)
{
    if (ServiceData_setHandler(value)) {
        Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>> value_get =
            Glib::Variant<std::map<Glib::ustring,Glib::VariantBase>>::create((ServiceData_get()));

        emitSignal("ServiceData", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::TxPower_set(gint16 value)
{
    if (TxPower_setHandler(value)) {
        Glib::Variant<gint16> value_get =
            Glib::Variant<gint16>::create((TxPower_get()));

        emitSignal("TxPower", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::ServicesResolved_set(bool value)
{
    if (ServicesResolved_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((ServicesResolved_get()));

        emitSignal("ServicesResolved", value_get);
        return true;
    }

    return false;
}

bool bluez::Device1Stub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
