#pragma once
#include <string>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/bluez_device_dbus_common.h"

namespace bluez {

class Device1Stub : public sigc::trackable {
public:
    Device1Stub();
    virtual ~Device1Stub();

    Device1Stub(const Device1Stub &other) = delete;
    Device1Stub(Device1Stub &&other) = delete;
    Device1Stub &operator=(const Device1Stub &other) = delete;
    Device1Stub &operator=(Device1Stub &&other) = delete;

    guint register_object(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                          const Glib::ustring &object_path);
    void unregister_object();

    unsigned int usage_count() const {
        return static_cast<unsigned int>(m_registered_objects.size());
    }

    class MethodInvocation;

    bool Address_set(const Glib::ustring & value);
    bool AddressType_set(const Glib::ustring & value);
    bool Name_set(const Glib::ustring & value);
    bool Alias_set(const Glib::ustring & value);
    bool Class_set(guint32 value);
    bool Appearance_set(guint16 value);
    bool Icon_set(const Glib::ustring & value);
    bool Paired_set(bool value);
    bool Trusted_set(bool value);
    bool Blocked_set(bool value);
    bool LegacyPairing_set(bool value);
    bool RSSI_set(gint16 value);
    bool Connected_set(bool value);
    bool UUIDs_set(const std::vector<Glib::ustring> & value);
    bool Modalias_set(const Glib::ustring & value);
    bool Adapter_set(const Glib::DBusObjectPathString & value);
    bool ManufacturerData_set(const std::map<guint16,Glib::VariantBase> & value);
    bool ServiceData_set(const std::map<Glib::ustring,Glib::VariantBase> & value);
    bool TxPower_set(gint16 value);
    bool ServicesResolved_set(bool value);
protected:
    virtual void Disconnect(
        MethodInvocation &invocation) = 0;
    virtual void Connect(
        MethodInvocation &invocation) = 0;
    virtual void ConnectProfile(
        const Glib::ustring & UUID,
        MethodInvocation &invocation) = 0;
    virtual void DisconnectProfile(
        const Glib::ustring & UUID,
        MethodInvocation &invocation) = 0;
    virtual void Pair(
        MethodInvocation &invocation) = 0;
    virtual void CancelPairing(
        MethodInvocation &invocation) = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Address_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Address_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool AddressType_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring AddressType_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Name_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Name_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Alias_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Alias_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Class_setHandler(guint32 value) = 0;
    virtual guint32 Class_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Appearance_setHandler(guint16 value) = 0;
    virtual guint16 Appearance_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Icon_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Icon_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Paired_setHandler(bool value) = 0;
    virtual bool Paired_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Trusted_setHandler(bool value) = 0;
    virtual bool Trusted_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Blocked_setHandler(bool value) = 0;
    virtual bool Blocked_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool LegacyPairing_setHandler(bool value) = 0;
    virtual bool LegacyPairing_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool RSSI_setHandler(gint16 value) = 0;
    virtual gint16 RSSI_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Connected_setHandler(bool value) = 0;
    virtual bool Connected_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool UUIDs_setHandler(const std::vector<Glib::ustring> & value) = 0;
    virtual std::vector<Glib::ustring> UUIDs_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Modalias_setHandler(const Glib::ustring & value) = 0;
    virtual Glib::ustring Modalias_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool Adapter_setHandler(const Glib::DBusObjectPathString & value) = 0;
    virtual Glib::DBusObjectPathString Adapter_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool ManufacturerData_setHandler(const std::map<guint16,Glib::VariantBase> & value) = 0;
    virtual std::map<guint16,Glib::VariantBase> ManufacturerData_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool ServiceData_setHandler(const std::map<Glib::ustring,Glib::VariantBase> & value) = 0;
    virtual std::map<Glib::ustring,Glib::VariantBase> ServiceData_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool TxPower_setHandler(gint16 value) = 0;
    virtual gint16 TxPower_get() = 0;

    /* Handle the setting of a property
     * This method will be called as a result of a call to <PropName>_set
     * and should implement the actual setting of the property value.
     * Should return true on success and false otherwise.
     */
    virtual bool ServicesResolved_setHandler(bool value) = 0;
    virtual bool ServicesResolved_get() = 0;

    void on_method_call(const Glib::RefPtr<Gio::DBus::Connection> &connection,
                        const Glib::ustring &sender,
                        const Glib::ustring &object_path,
                        const Glib::ustring &interface_name,
                        const Glib::ustring &method_name,
                        const Glib::VariantContainerBase &parameters,
                        const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation);

    void on_interface_get_property(Glib::VariantBase& property,
                                   const Glib::RefPtr<Gio::DBus::Connection> &connection,
                                   const Glib::ustring &sender,
                                   const Glib::ustring &object_path,
                                   const Glib::ustring &interface_name,
                                   const Glib::ustring &property_name);

    bool on_interface_set_property(
        const Glib::RefPtr<Gio::DBus::Connection> &connection,
        const Glib::ustring &sender,
        const Glib::ustring &object_path,
        const Glib::ustring &interface_name,
        const Glib::ustring &property_name,
        const Glib::VariantBase &value);

private:
    bool emitSignal(const std::string &propName, Glib::VariantBase &value);

    struct RegisteredObject {
        guint id;
        Glib::RefPtr<Gio::DBus::Connection> connection;
        std::string object_path;
    };

    Glib::RefPtr<Gio::DBus::NodeInfo> introspection_data;
    std::vector<RegisteredObject> m_registered_objects;
    std::string m_interfaceName;
};

class Device1Stub::MethodInvocation {
public:
    MethodInvocation(const Glib::RefPtr<Gio::DBus::MethodInvocation> &msg):
        m_message(msg) {}

    const Glib::RefPtr<Gio::DBus::MethodInvocation> getMessage() {
        return m_message;
    }

    void ret(Glib::Error error) {
        m_message->return_error(error);
    }

    void returnError(const Glib::ustring &domain, int code, const Glib::ustring &message) {
        m_message->return_error(domain, code, message);
    }

    void ret() {
        std::vector<Glib::VariantBase> vlist;

        m_message->return_value(Glib::Variant<Glib::VariantBase>::create_tuple(vlist));
    }

private:
    Glib::RefPtr<Gio::DBus::MethodInvocation> m_message;
};

} // bluez

