static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SystemDaemon.Greeter">

        <method name="SetBackground">
            <arg name="file_path" direction="in" type="s">
            </arg>
            <description>Setting the background image path of login interface.</description>
        </method>

        <method name="SetAutologinUser">
            <arg name="user_name" direction="in" type="s">
            </arg>
            <description>Set automatic login user name.</description>
        </method>

        <method name="SetAutologinTimeout">
            <arg name="seconds" direction="in" type="t">
            </arg>
            <description>Set the automatic login delay in seconds.</description>
        </method>

        <method name="SetHideUserList">
            <arg name="hide" direction="in" type="b">
            </arg>
            <description>Set whether to hide the user list.</description>
        </method>

        <method name="SetAllowManualLogin">
            <arg name="allow" direction="in" type="b">
            </arg>
            <description>Set whether manual login is allowed.</description>
        </method>

        <method name="SetScaleMode">
            <arg name="mode" direction="in" type="q">
                <summary>The new username.</summary>
            </arg>
            <arg name="factor" direction="in" type="q">
                <summary>The mode can be 0, 1 or 2, where 0 means automatic, 1 means manual and 2 means disabled.</summary>
            </arg>
            <description>Factor is the scale factor, 1 is 100%, 2 is 200%. The factor parameter is valid only when mode is 1.</description>
        </method>

        <property name="background" type="s" access="read">
        </property>

        <property name="autologin_user" type="s" access="read">
        </property>

        <property name="autologin_timeout" type="t" access="read">
        </property>

        <property name="allow_manual_login" type="b" access="read">
        </property>

        <property name="hide_user_list" type="b" access="read">
        </property>

        <property name="scale_mode" type="q" access="read">
        </property>

        <property name="scale_factor" type="q" access="read">
        </property>

    </interface>
</node>)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/greeter_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SystemDaemon::GreeterStub::GreeterStub():
    m_interfaceName("com.kylinsec.Kiran.SystemDaemon.Greeter")
{
}

Kiran::SystemDaemon::GreeterStub::~GreeterStub()
{
    unregister_object();
}

guint Kiran::SystemDaemon::GreeterStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &GreeterStub::on_method_call),
            sigc::mem_fun(this, &GreeterStub::on_interface_get_property),
            sigc::mem_fun(this, &GreeterStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SystemDaemon.Greeter"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SystemDaemon::GreeterStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SystemDaemon::GreeterStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("SetBackground") == 0) {
        Glib::Variant<Glib::ustring> base_file_path;
        parameters.get_child(base_file_path, 0);
        Glib::ustring p_file_path = specialGetter(base_file_path);

        MethodInvocation methodInvocation(invocation);
        SetBackground(
            (p_file_path),
            methodInvocation);
    }

    if (method_name.compare("SetAutologinUser") == 0) {
        Glib::Variant<Glib::ustring> base_user_name;
        parameters.get_child(base_user_name, 0);
        Glib::ustring p_user_name = specialGetter(base_user_name);

        MethodInvocation methodInvocation(invocation);
        SetAutologinUser(
            (p_user_name),
            methodInvocation);
    }

    if (method_name.compare("SetAutologinTimeout") == 0) {
        Glib::Variant<guint64> base_seconds;
        parameters.get_child(base_seconds, 0);
        guint64 p_seconds = specialGetter(base_seconds);

        MethodInvocation methodInvocation(invocation);
        SetAutologinTimeout(
            (p_seconds),
            methodInvocation);
    }

    if (method_name.compare("SetHideUserList") == 0) {
        Glib::Variant<bool> base_hide;
        parameters.get_child(base_hide, 0);
        bool p_hide = specialGetter(base_hide);

        MethodInvocation methodInvocation(invocation);
        SetHideUserList(
            (p_hide),
            methodInvocation);
    }

    if (method_name.compare("SetAllowManualLogin") == 0) {
        Glib::Variant<bool> base_allow;
        parameters.get_child(base_allow, 0);
        bool p_allow = specialGetter(base_allow);

        MethodInvocation methodInvocation(invocation);
        SetAllowManualLogin(
            (p_allow),
            methodInvocation);
    }

    if (method_name.compare("SetScaleMode") == 0) {
        Glib::Variant<guint16> base_mode;
        parameters.get_child(base_mode, 0);
        guint16 p_mode = specialGetter(base_mode);

        Glib::Variant<guint16> base_factor;
        parameters.get_child(base_factor, 1);
        guint16 p_factor = specialGetter(base_factor);

        MethodInvocation methodInvocation(invocation);
        SetScaleMode(
            (p_mode),
            (p_factor),
            methodInvocation);
    }

}

void Kiran::SystemDaemon::GreeterStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("background") == 0) {

        property = Glib::Variant<Glib::ustring>::create((background_get()));
    }

    if (property_name.compare("autologin_user") == 0) {

        property = Glib::Variant<Glib::ustring>::create((autologin_user_get()));
    }

    if (property_name.compare("autologin_timeout") == 0) {

        property = Glib::Variant<guint64>::create((autologin_timeout_get()));
    }

    if (property_name.compare("allow_manual_login") == 0) {

        property = Glib::Variant<bool>::create((allow_manual_login_get()));
    }

    if (property_name.compare("hide_user_list") == 0) {

        property = Glib::Variant<bool>::create((hide_user_list_get()));
    }

    if (property_name.compare("scale_mode") == 0) {

        property = Glib::Variant<guint16>::create((scale_mode_get()));
    }

    if (property_name.compare("scale_factor") == 0) {

        property = Glib::Variant<guint16>::create((scale_factor_get()));
    }

}

bool Kiran::SystemDaemon::GreeterStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SystemDaemon::GreeterStub::background_set(const Glib::ustring & value)
{
    if (background_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((background_get()));

        emitSignal("background", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::autologin_user_set(const Glib::ustring & value)
{
    if (autologin_user_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((autologin_user_get()));

        emitSignal("autologin_user", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::autologin_timeout_set(guint64 value)
{
    if (autologin_timeout_setHandler(value)) {
        Glib::Variant<guint64> value_get =
            Glib::Variant<guint64>::create((autologin_timeout_get()));

        emitSignal("autologin_timeout", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::allow_manual_login_set(bool value)
{
    if (allow_manual_login_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((allow_manual_login_get()));

        emitSignal("allow_manual_login", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::hide_user_list_set(bool value)
{
    if (hide_user_list_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((hide_user_list_get()));

        emitSignal("hide_user_list", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::scale_mode_set(guint16 value)
{
    if (scale_mode_setHandler(value)) {
        Glib::Variant<guint16> value_get =
            Glib::Variant<guint16>::create((scale_mode_get()));

        emitSignal("scale_mode", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::scale_factor_set(guint16 value)
{
    if (scale_factor_setHandler(value)) {
        Glib::Variant<guint16> value_get =
            Glib::Variant<guint16>::create((scale_factor_get()));

        emitSignal("scale_factor", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::GreeterStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
