#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/keybinding_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {

class KeybindingProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<KeybindingProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<KeybindingProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void AddCustomShortcut(
        const Glib::ustring & name,
        const Glib::ustring & action,
        const Glib::ustring & key_combination,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddCustomShortcut_finish (
        Glib::ustring &uid,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    AddCustomShortcut_sync(
        const Glib::ustring & name,        const Glib::ustring & action,        const Glib::ustring & key_combination,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ModifyCustomShortcut(
        const Glib::ustring & uid,
        const Glib::ustring & name,
        const Glib::ustring & action,
        const Glib::ustring & key_combination,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ModifyCustomShortcut_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    ModifyCustomShortcut_sync(
        const Glib::ustring & uid,        const Glib::ustring & name,        const Glib::ustring & action,        const Glib::ustring & key_combination,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DeleteCustomShortcut(
        const Glib::ustring & uid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DeleteCustomShortcut_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DeleteCustomShortcut_sync(
        const Glib::ustring & uid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetCustomShortcut(
        const Glib::ustring & uid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetCustomShortcut_finish (
        Glib::ustring &shortcut,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetCustomShortcut_sync(
        const Glib::ustring & uid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListCustomShortcuts(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListCustomShortcuts_finish (
        Glib::ustring &shortcuts,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    ListCustomShortcuts_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ModifySystemShortcut(
        const Glib::ustring & uid,
        const Glib::ustring & key_combination,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ModifySystemShortcut_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    ModifySystemShortcut_sync(
        const Glib::ustring & uid,        const Glib::ustring & key_combination,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSystemShortcut(
        const Glib::ustring & uid,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetSystemShortcut_finish (
        Glib::ustring &shortcut,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetSystemShortcut_sync(
        const Glib::ustring & uid,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListSystemShortcuts(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListSystemShortcuts_finish (
        Glib::ustring &shortcuts,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    ListSystemShortcuts_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListShortcuts(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListShortcuts_finish (
        Glib::ustring &shortcuts,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    ListShortcuts_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    sigc::signal<void, Glib::ustring > Added_signal;
    sigc::signal<void, Glib::ustring > Deleted_signal;
    sigc::signal<void, Glib::ustring > Changed_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    KeybindingProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

};

}// SessionDaemon
}// Kiran

