static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Keybinding">
        <method name="AddCustomShortcut">
            <arg type="s" name="name" direction="in">
                <summary>The shortcut name.</summary>
            </arg>
            <arg type="s" name="action" direction="in">
                <summary>Execute command.</summary>
            </arg>
            <arg type="s" name="key_combination" direction="in">
                <summary>The keystroke combination.</summary>
            </arg>
            <arg type="s" name="uid" direction="out">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <description>Add a custom shortcut. Execute the action when press the keystroke combination.</description>
        </method>

        <method name="ModifyCustomShortcut">
            <arg type="s" name="uid" direction="in">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <arg type="s" name="name" direction="in">
                <summary>The shortcut name.</summary>
            </arg>
            <arg type="s" name="action" direction="in">
                <summary>Execute command.</summary>
            </arg>
            <arg type="s" name="key_combination" direction="in">
                <summary>The keystroke combination.</summary>
            </arg>
            <description>Modify existed custom shortcut.</description>
        </method>

        <method name="DeleteCustomShortcut">
            <arg type="s" name="uid" direction="in">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <description>Delete existed custom shortcut.</description>
        </method>

        <method name="GetCustomShortcut">
            <arg type="s" name="uid" direction="in">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <arg type="s" name="shortcut" direction="out">
                <summary>The shortcut is a json string which contains uid, name, action and key_combination. the json key refers to keybinding-i.h</summary>
            </arg>
            <description>Get custom shortcut.</description>
        </method>

        <method name="ListCustomShortcuts">
            <arg type="s" name="shortcuts" direction="out">
                <summary>The shortcuts is a json string which is a list that contains uid, name, action and key_combination. the json key refers to keybinding-i.h</summary>
            </arg>
            <description>List custom shortcuts.</description>
        </method>

        <method name="ModifySystemShortcut">
            <arg type="s" name="uid" direction="in">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <arg type="s" name="key_combination" direction="in">
                <summary>The keystroke combination.</summary>
            </arg>
            <description>Modify existed system shortcut.</description>
        </method>

        <method name="GetSystemShortcut">
            <arg type="s" name="uid" direction="in">
                <summary>The unique ID to identify the shortcut.</summary>
            </arg>
            <arg type="s" name="shortcut" direction="out">
                <summary>The shortcut is a json string that contains uid, name, kind and key_combination. the json key refers to keybinding-i.h.</summary>
            </arg>
            <description>Get system shortcut.</description>
        </method>

        <method name="ListSystemShortcuts">
            <arg type="s" name="shortcuts" direction="out">
                <summary>The shortcuts is a json string which is a list that contains uid, name, kind and key_combination. the json key refers to keybinding-i.h.</summary>
            </arg>
            <description>List system shortcuts.</description>
        </method>

        <method name="ListShortcuts">
            <arg type="s" name="shortcuts" direction="out">
                <summary>The shortcuts is a json string list custom and system info, 
                the custom that contains uid, name, action and key_combination, 
                the system that contains uid, name, kind and key_combination. 
                the json key refers to keybinding-i.h.</summary>
            </arg>
            <description>List all shortcuts that contain custom shortcuts and system shortcuts.</description>
        </method>

        <signal name="Added">
            <arg type="s" name="result">
                <summary>The struct is a json string which contains uid and kind.</summary>
            </arg>
        </signal>

        <signal name="Deleted">
            <arg type="s" name="result">
                <summary>The struct is a json string which contains uid and kind.</summary>
            </arg>
        </signal>

        <signal name="Changed">
            <arg type="s" name="result">
                <summary>The struct is a json string which contains uid and kind.</summary>
            </arg>
        </signal>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/keybinding_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::KeybindingStub::KeybindingStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Keybinding")
{
    Added_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &KeybindingStub::Added_emitter),
            std::vector<Glib::ustring>({""})) );
    Added_selectiveSignal.connect(sigc::mem_fun(this, &KeybindingStub::Added_emitter));
    Deleted_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &KeybindingStub::Deleted_emitter),
            std::vector<Glib::ustring>({""})) );
    Deleted_selectiveSignal.connect(sigc::mem_fun(this, &KeybindingStub::Deleted_emitter));
    Changed_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &KeybindingStub::Changed_emitter),
            std::vector<Glib::ustring>({""})) );
    Changed_selectiveSignal.connect(sigc::mem_fun(this, &KeybindingStub::Changed_emitter));
}

Kiran::SessionDaemon::KeybindingStub::~KeybindingStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::KeybindingStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &KeybindingStub::on_method_call),
            sigc::mem_fun(this, &KeybindingStub::on_interface_get_property),
            sigc::mem_fun(this, &KeybindingStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Keybinding"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::KeybindingStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::KeybindingStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("AddCustomShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        Glib::Variant<Glib::ustring> base_action;
        parameters.get_child(base_action, 1);
        Glib::ustring p_action = specialGetter(base_action);

        Glib::Variant<Glib::ustring> base_key_combination;
        parameters.get_child(base_key_combination, 2);
        Glib::ustring p_key_combination = specialGetter(base_key_combination);

        MethodInvocation methodInvocation(invocation);
        AddCustomShortcut(
            (p_name),
            (p_action),
            (p_key_combination),
            methodInvocation);
    }

    if (method_name.compare("ModifyCustomShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_uid;
        parameters.get_child(base_uid, 0);
        Glib::ustring p_uid = specialGetter(base_uid);

        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 1);
        Glib::ustring p_name = specialGetter(base_name);

        Glib::Variant<Glib::ustring> base_action;
        parameters.get_child(base_action, 2);
        Glib::ustring p_action = specialGetter(base_action);

        Glib::Variant<Glib::ustring> base_key_combination;
        parameters.get_child(base_key_combination, 3);
        Glib::ustring p_key_combination = specialGetter(base_key_combination);

        MethodInvocation methodInvocation(invocation);
        ModifyCustomShortcut(
            (p_uid),
            (p_name),
            (p_action),
            (p_key_combination),
            methodInvocation);
    }

    if (method_name.compare("DeleteCustomShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_uid;
        parameters.get_child(base_uid, 0);
        Glib::ustring p_uid = specialGetter(base_uid);

        MethodInvocation methodInvocation(invocation);
        DeleteCustomShortcut(
            (p_uid),
            methodInvocation);
    }

    if (method_name.compare("GetCustomShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_uid;
        parameters.get_child(base_uid, 0);
        Glib::ustring p_uid = specialGetter(base_uid);

        MethodInvocation methodInvocation(invocation);
        GetCustomShortcut(
            (p_uid),
            methodInvocation);
    }

    if (method_name.compare("ListCustomShortcuts") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListCustomShortcuts(
            methodInvocation);
    }

    if (method_name.compare("ModifySystemShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_uid;
        parameters.get_child(base_uid, 0);
        Glib::ustring p_uid = specialGetter(base_uid);

        Glib::Variant<Glib::ustring> base_key_combination;
        parameters.get_child(base_key_combination, 1);
        Glib::ustring p_key_combination = specialGetter(base_key_combination);

        MethodInvocation methodInvocation(invocation);
        ModifySystemShortcut(
            (p_uid),
            (p_key_combination),
            methodInvocation);
    }

    if (method_name.compare("GetSystemShortcut") == 0) {
        Glib::Variant<Glib::ustring> base_uid;
        parameters.get_child(base_uid, 0);
        Glib::ustring p_uid = specialGetter(base_uid);

        MethodInvocation methodInvocation(invocation);
        GetSystemShortcut(
            (p_uid),
            methodInvocation);
    }

    if (method_name.compare("ListSystemShortcuts") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListSystemShortcuts(
            methodInvocation);
    }

    if (method_name.compare("ListShortcuts") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListShortcuts(
            methodInvocation);
    }

}

void Kiran::SessionDaemon::KeybindingStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

}

bool Kiran::SessionDaemon::KeybindingStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}

void Kiran::SessionDaemon::KeybindingStub::Added_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::ustring & result)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::ustring>::create((result)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Keybinding",
                    "Added",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::KeybindingStub::Deleted_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::ustring & result)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::ustring>::create((result)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Keybinding",
                    "Deleted",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::KeybindingStub::Changed_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,const Glib::ustring & result)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<Glib::ustring>::create((result)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Keybinding",
                    "Changed",
                    bus_name,
                    params);
        }
    }
}


bool Kiran::SessionDaemon::KeybindingStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
