#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/keyboard_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {

class KeyboardProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<KeyboardProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<KeyboardProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void AddLayout(
        const Glib::ustring & layout,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddLayout_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    AddLayout_sync(
        const Glib::ustring & layout,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelLayout(
        const Glib::ustring & layout,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelLayout_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DelLayout_sync(
        const Glib::ustring & layout,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ApplyLayout(
        const Glib::ustring & layout,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ApplyLayout_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    ApplyLayout_sync(
        const Glib::ustring & layout,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetValidLayouts(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetValidLayouts_finish (
        Glib::ustring &layouts,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetValidLayouts_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddLayoutOption(
        const Glib::ustring & option,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddLayoutOption_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    AddLayoutOption_sync(
        const Glib::ustring & option,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelLayoutOption(
        const Glib::ustring & option,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelLayoutOption_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DelLayoutOption_sync(
        const Glib::ustring & option,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ClearLayoutOption(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ClearLayoutOption_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    ClearLayoutOption_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    bool repeat_enabled_get(bool *ok = nullptr);
    void repeat_enabled_set(bool, const Gio::SlotAsyncReady &);
    void repeat_enabled_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void repeat_enabled_set_sync(bool);
    sigc::signal<void> &repeat_enabled_changed() {
        return m_repeat_enabled_changed;
    }

    gint32 repeat_delay_get(bool *ok = nullptr);
    void repeat_delay_set(gint32, const Gio::SlotAsyncReady &);
    void repeat_delay_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void repeat_delay_set_sync(gint32);
    sigc::signal<void> &repeat_delay_changed() {
        return m_repeat_delay_changed;
    }

    gint32 repeat_interval_get(bool *ok = nullptr);
    void repeat_interval_set(gint32, const Gio::SlotAsyncReady &);
    void repeat_interval_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void repeat_interval_set_sync(gint32);
    sigc::signal<void> &repeat_interval_changed() {
        return m_repeat_interval_changed;
    }

    std::vector<Glib::ustring> layouts_get(bool *ok = nullptr);
    void layouts_set(const std::vector<Glib::ustring> &, const Gio::SlotAsyncReady &);
    void layouts_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void layouts_set_sync(const std::vector<Glib::ustring> &);
    sigc::signal<void> &layouts_changed() {
        return m_layouts_changed;
    }

    std::vector<Glib::ustring> options_get(bool *ok = nullptr);
    void options_set(const std::vector<Glib::ustring> &, const Gio::SlotAsyncReady &);
    void options_set_finish(const Glib::RefPtr<Gio::AsyncResult> &);
    void options_set_sync(const std::vector<Glib::ustring> &);
    sigc::signal<void> &options_changed() {
        return m_options_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    KeyboardProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_repeat_enabled_changed;
    sigc::signal<void> m_repeat_delay_changed;
    sigc::signal<void> m_repeat_interval_changed;
    sigc::signal<void> m_layouts_changed;
    sigc::signal<void> m_options_changed;
};

}// SessionDaemon
}// Kiran

