static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Keyboard">
        <method name="AddLayout">
            <arg type="s" name="layout" direction="in">
                <summary>Layout name. example us, cn, etc</summary>
            </arg>
            <description>Add an user layout to usr layout lists.</description>
        </method>

        <method name="DelLayout">
            <arg type="s" name="layout" direction="in">
                <summary>Layout name. example us, cn, etc</summary>
            </arg>
            <description>Delete an user layout from usr layout lists.</description>
        </method>

        <method name="ApplyLayout">
            <arg type="s" name="layout" direction="in">
                <summary>Layout name.</summary>
            </arg>
            <description>Apply the layout which is added by AddLayout.</description>
        </method>

        <method name="GetValidLayouts">
            <arg type="s" name="layouts" direction="out">
                <summary>All valid layout list that is json string.</summary>
            </arg>
            <description>Get all valid layout list from the file /usr/share/X11/xkb/rules/base.xml</description>
        </method>

        <method name="AddLayoutOption">
            <arg type="s" name="option" direction="in">
                <summary>layout option.</summary>
            </arg>
            <description>add layout option.</description>
        </method>

        <method name="DelLayoutOption">
            <arg type="s" name="option" direction="in">
                <summary>layout option.</summary>
            </arg>
            <description>delete layout option.</description>
        </method>

        <method name="ClearLayoutOption">
            <description>clear layout option.</description>
        </method>

        <property name="repeat_enabled" type="b" access="readwrite">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>Whether repeat to trigger KeyPress and KeyRelease event when key is pressed.</description>
        </property>

        <property name="repeat_delay" type="i" access="readwrite">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The delay time in ms after the initial press of an auto-repeating key and the first generated repeat event.</description>
        </property>

        <property name="repeat_interval" type="i" access="readwrite">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The delay time in ms between all subsequent generated repeat events.</description>
        </property>


        <property name="layouts" type="as" access="readwrite">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>Keyboard layouts.</description>

        </property>

        <property name="options" type="as" access="readwrite">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>Keyboard options.</description>
        </property>
    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/keyboard_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::KeyboardStub::KeyboardStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Keyboard")
{
}

Kiran::SessionDaemon::KeyboardStub::~KeyboardStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::KeyboardStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &KeyboardStub::on_method_call),
            sigc::mem_fun(this, &KeyboardStub::on_interface_get_property),
            sigc::mem_fun(this, &KeyboardStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Keyboard"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::KeyboardStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::KeyboardStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("AddLayout") == 0) {
        Glib::Variant<Glib::ustring> base_layout;
        parameters.get_child(base_layout, 0);
        Glib::ustring p_layout = specialGetter(base_layout);

        MethodInvocation methodInvocation(invocation);
        AddLayout(
            (p_layout),
            methodInvocation);
    }

    if (method_name.compare("DelLayout") == 0) {
        Glib::Variant<Glib::ustring> base_layout;
        parameters.get_child(base_layout, 0);
        Glib::ustring p_layout = specialGetter(base_layout);

        MethodInvocation methodInvocation(invocation);
        DelLayout(
            (p_layout),
            methodInvocation);
    }

    if (method_name.compare("ApplyLayout") == 0) {
        Glib::Variant<Glib::ustring> base_layout;
        parameters.get_child(base_layout, 0);
        Glib::ustring p_layout = specialGetter(base_layout);

        MethodInvocation methodInvocation(invocation);
        ApplyLayout(
            (p_layout),
            methodInvocation);
    }

    if (method_name.compare("GetValidLayouts") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetValidLayouts(
            methodInvocation);
    }

    if (method_name.compare("AddLayoutOption") == 0) {
        Glib::Variant<Glib::ustring> base_option;
        parameters.get_child(base_option, 0);
        Glib::ustring p_option = specialGetter(base_option);

        MethodInvocation methodInvocation(invocation);
        AddLayoutOption(
            (p_option),
            methodInvocation);
    }

    if (method_name.compare("DelLayoutOption") == 0) {
        Glib::Variant<Glib::ustring> base_option;
        parameters.get_child(base_option, 0);
        Glib::ustring p_option = specialGetter(base_option);

        MethodInvocation methodInvocation(invocation);
        DelLayoutOption(
            (p_option),
            methodInvocation);
    }

    if (method_name.compare("ClearLayoutOption") == 0) {
        MethodInvocation methodInvocation(invocation);
        ClearLayoutOption(
            methodInvocation);
    }

}

void Kiran::SessionDaemon::KeyboardStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("repeat_enabled") == 0) {

        property = Glib::Variant<bool>::create((repeat_enabled_get()));
    }

    if (property_name.compare("repeat_delay") == 0) {

        property = Glib::Variant<gint32>::create((repeat_delay_get()));
    }

    if (property_name.compare("repeat_interval") == 0) {

        property = Glib::Variant<gint32>::create((repeat_interval_get()));
    }

    if (property_name.compare("layouts") == 0) {

        property = Glib::Variant<std::vector<Glib::ustring>>::create((layouts_get()));
    }

    if (property_name.compare("options") == 0) {

        property = Glib::Variant<std::vector<Glib::ustring>>::create((options_get()));
    }

}

bool Kiran::SessionDaemon::KeyboardStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    if (property_name.compare("repeat_enabled") == 0) {
        try {
            Glib::Variant<bool> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<bool>>(value);
            bool val =
                (specialGetter(castValue));
            repeat_enabled_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting repeat_enabled");
        }
    }

    if (property_name.compare("repeat_delay") == 0) {
        try {
            Glib::Variant<gint32> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<gint32>>(value);
            gint32 val =
                (specialGetter(castValue));
            repeat_delay_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting repeat_delay");
        }
    }

    if (property_name.compare("repeat_interval") == 0) {
        try {
            Glib::Variant<gint32> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<gint32>>(value);
            gint32 val =
                (specialGetter(castValue));
            repeat_interval_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting repeat_interval");
        }
    }

    if (property_name.compare("layouts") == 0) {
        try {
            Glib::Variant<std::vector<Glib::ustring>> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<std::vector<Glib::ustring>>>(value);
            std::vector<Glib::ustring> val =
                (specialGetter(castValue));
            layouts_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting layouts");
        }
    }

    if (property_name.compare("options") == 0) {
        try {
            Glib::Variant<std::vector<Glib::ustring>> castValue =
                Glib::VariantBase::cast_dynamic<Glib::Variant<std::vector<Glib::ustring>>>(value);
            std::vector<Glib::ustring> val =
                (specialGetter(castValue));
            options_set(val);
        } catch (const std::bad_cast &) {
            g_warning ("Bad cast when casting options");
        }
    }

    return true;
}


bool Kiran::SessionDaemon::KeyboardStub::repeat_enabled_set(bool value)
{
    if (repeat_enabled_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((repeat_enabled_get()));

        emitSignal("repeat_enabled", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::KeyboardStub::repeat_delay_set(gint32 value)
{
    if (repeat_delay_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((repeat_delay_get()));

        emitSignal("repeat_delay", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::KeyboardStub::repeat_interval_set(gint32 value)
{
    if (repeat_interval_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((repeat_interval_get()));

        emitSignal("repeat_interval", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::KeyboardStub::layouts_set(const std::vector<Glib::ustring> & value)
{
    if (layouts_setHandler(value)) {
        Glib::Variant<std::vector<Glib::ustring>> value_get =
            Glib::Variant<std::vector<Glib::ustring>>::create((layouts_get()));

        emitSignal("layouts", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::KeyboardStub::options_set(const std::vector<Glib::ustring> & value)
{
    if (options_setHandler(value)) {
        Glib::Variant<std::vector<Glib::ustring>> value_get =
            Glib::Variant<std::vector<Glib::ustring>>::create((options_get()));

        emitSignal("options", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::KeyboardStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
