#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/monitor_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {
namespace Display {

class MonitorProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<MonitorProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<MonitorProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void Enable(
        bool enabled,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void Enable_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    Enable_sync(
        bool enabled,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListModes(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListModes_finish (
        std::vector<std::tuple<guint32,guint32,guint32,double>> &modes,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<std::tuple<guint32,guint32,guint32,double>>
    ListModes_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListPreferredModes(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListPreferredModes_finish (
        std::vector<std::tuple<guint32,guint32,guint32,double>> &preferred_modes,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<std::tuple<guint32,guint32,guint32,double>>
    ListPreferredModes_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetCurrentMode(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetCurrentMode_finish (
        std::tuple<guint32,guint32,guint32,double> &mode,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::tuple<guint32,guint32,guint32,double>
    GetCurrentMode_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetMode(
        guint32 width,
        guint32 height,
        double refresh_rate,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetMode_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetMode_sync(
        guint32 width,        guint32 height,        double refresh_rate,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetModeById(
        guint32 id,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetModeById_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetModeById_sync(
        guint32 id,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetModeBySize(
        guint32 width,
        guint32 height,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetModeBySize_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetModeBySize_sync(
        guint32 width,        guint32 height,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPosition(
        gint32 x,
        gint32 y,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPosition_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetPosition_sync(
        gint32 x,        gint32 y,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetRotation(
        guint16 rotation,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetRotation_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetRotation_sync(
        guint16 rotation,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetReflect(
        guint16 reflect,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetReflect_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetReflect_sync(
        guint16 reflect,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    guint32 id_get(bool *ok = nullptr);
    sigc::signal<void> &id_changed() {
        return m_id_changed;
    }

    Glib::ustring name_get(bool *ok = nullptr);
    sigc::signal<void> &name_changed() {
        return m_name_changed;
    }

    bool connected_get(bool *ok = nullptr);
    sigc::signal<void> &connected_changed() {
        return m_connected_changed;
    }

    bool enabled_get(bool *ok = nullptr);
    sigc::signal<void> &enabled_changed() {
        return m_enabled_changed;
    }

    gint32 x_get(bool *ok = nullptr);
    sigc::signal<void> &x_changed() {
        return m_x_changed;
    }

    gint32 y_get(bool *ok = nullptr);
    sigc::signal<void> &y_changed() {
        return m_y_changed;
    }

    guint16 rotation_get(bool *ok = nullptr);
    sigc::signal<void> &rotation_changed() {
        return m_rotation_changed;
    }

    guint16 reflect_get(bool *ok = nullptr);
    sigc::signal<void> &reflect_changed() {
        return m_reflect_changed;
    }

    std::vector<guint16> rotations_get(bool *ok = nullptr);
    sigc::signal<void> &rotations_changed() {
        return m_rotations_changed;
    }

    std::vector<guint16> reflects_get(bool *ok = nullptr);
    sigc::signal<void> &reflects_changed() {
        return m_reflects_changed;
    }

    guint32 current_mode_get(bool *ok = nullptr);
    sigc::signal<void> &current_mode_changed() {
        return m_current_mode_changed;
    }

    std::vector<guint32> modes_get(bool *ok = nullptr);
    sigc::signal<void> &modes_changed() {
        return m_modes_changed;
    }

    gint32 npreferred_get(bool *ok = nullptr);
    sigc::signal<void> &npreferred_changed() {
        return m_npreferred_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    MonitorProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_id_changed;
    sigc::signal<void> m_name_changed;
    sigc::signal<void> m_connected_changed;
    sigc::signal<void> m_enabled_changed;
    sigc::signal<void> m_x_changed;
    sigc::signal<void> m_y_changed;
    sigc::signal<void> m_rotation_changed;
    sigc::signal<void> m_reflect_changed;
    sigc::signal<void> m_rotations_changed;
    sigc::signal<void> m_reflects_changed;
    sigc::signal<void> m_current_mode_changed;
    sigc::signal<void> m_modes_changed;
    sigc::signal<void> m_npreferred_changed;
};

}// Display
}// SessionDaemon
}// Kiran

