static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Display.Monitor">

        <method name="Enable">
            <arg type="b" name="enabled" direction="in">
                <doc:doc>
                    <doc:summary>The show of the monitor is opened or closed.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Open or close the monitor.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="ListModes">
            <arg type="a(uuud)" name="modes" direction="out">
                <doc:doc>
                    <doc:summary>The list of modes that element contains id, width, height and refresh_rate.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Get the list of modes supported by this monitor.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="ListPreferredModes">
            <arg type="a(uuud)" name="preferred_modes" direction="out">
                <doc:doc>
                    <doc:summary>The list of preferred modes that element contains id, width, height and refresh_rate.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Get the list of preferred modes by the monitor.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="GetCurrentMode">
            <arg type="(uuud)" name="mode" direction="out">
                <doc:doc>
                    <doc:summary>The current used mode that element contains id, width, height and refresh_rate.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Get the current used mode.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetMode">
            <arg type="u" name="width" direction="in">
                <doc:doc>
                    <doc:summary>The resolution in x-direction.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="u" name="height" direction="in">
                <doc:doc>
                    <doc:summary>The resolution in y-direction.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="d" name="refresh_rate" direction="in">
                <doc:doc>
                    <doc:summary>The refresh rate.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set mode.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetModeById">
            <arg type="u" name="id" direction="in">
                <doc:doc>
                    <doc:summary>The mode id.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set mode by id in property modes.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetModeBySize">
            <arg type="u" name="width" direction="in">
                <doc:doc>
                    <doc:summary>The resolution in x-direction.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="u" name="height" direction="in">
                <doc:doc>
                    <doc:summary>The resolution in y-direction.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set mode by size.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetPosition">
            <arg type="i" name="x" direction="in">
                <doc:doc>
                    <doc:summary>The x-direction position.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="i" name="y" direction="in">
                <doc:doc>
                    <doc:summary>The y-direction position.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set the position within the screen region..</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetRotation">
            <arg type="q" name="rotation" direction="in">
                <doc:doc>
                    <doc:summary>The rotation in property rotations.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set the rotation by value in property rotations.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <method name="SetReflect">
            <arg type="q" name="reflect" direction="in">
                <doc:doc>
                    <doc:summary>The reflect in property reflects.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>
                    <doc:para>Set the reflection by value in property reflects.</doc:para>
                </doc:description>
            </doc:doc>
        </method>

        <property name="id" type="u" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Indicates the Output id associate with this monitor.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="name" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Indicates the Output name associate with this monitor.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="connected" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Indecates whether the hardware was able to detect a monitor device connected to this output.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="enabled" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>The show of the monitor is opened or closed.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="x" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Indicates the position of this CRTC within the screen region.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="y" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Indicates the position of this CRTC within the screen region.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="rotation" type="q" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>The current rotation. Rotation can be one of 'normal', 'left', 'right' or 'inverted'. 
                    This causes the output contents to be rotated in the specified direction.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="reflect" type="q" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>The current reflection. Reflection can be one of 'normal' 'x', 'y' or 'xy'. This causes the output contents to be reflected across the specified axes.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="rotations" type="aq" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Contains the set of rotations supported by the CRTC.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="reflects" type="aq" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>Contains the set of reflections supported by the CRTC.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="current_mode" type="u" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>The current used mode.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="modes" type="au" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>All avaliable modes which element contains width, height and refresh rate. For exapmle: [(1920,1080, 60.0),(1680, 1050, 59.95)].</doc:para>
                </doc:description>
            </doc:doc>
        </property>

        <property name="npreferred" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>
                    <doc:para>The first npreferred modes in modes are preferred by the monitor in some way; for fixed-pixed devices,
                    this would generally indicate which modes match the resolution of the output device.</doc:para>
                </doc:description>
            </doc:doc>
        </property>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/monitor_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::Display::MonitorStub::MonitorStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Display.Monitor")
{
}

Kiran::SessionDaemon::Display::MonitorStub::~MonitorStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::Display::MonitorStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &MonitorStub::on_method_call),
            sigc::mem_fun(this, &MonitorStub::on_interface_get_property),
            sigc::mem_fun(this, &MonitorStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Display.Monitor"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::Display::MonitorStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::Display::MonitorStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("Enable") == 0) {
        Glib::Variant<bool> base_enabled;
        parameters.get_child(base_enabled, 0);
        bool p_enabled = specialGetter(base_enabled);

        MethodInvocation methodInvocation(invocation);
        Enable(
            (p_enabled),
            methodInvocation);
    }

    if (method_name.compare("ListModes") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListModes(
            methodInvocation);
    }

    if (method_name.compare("ListPreferredModes") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListPreferredModes(
            methodInvocation);
    }

    if (method_name.compare("GetCurrentMode") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetCurrentMode(
            methodInvocation);
    }

    if (method_name.compare("SetMode") == 0) {
        Glib::Variant<guint32> base_width;
        parameters.get_child(base_width, 0);
        guint32 p_width = specialGetter(base_width);

        Glib::Variant<guint32> base_height;
        parameters.get_child(base_height, 1);
        guint32 p_height = specialGetter(base_height);

        Glib::Variant<double> base_refresh_rate;
        parameters.get_child(base_refresh_rate, 2);
        double p_refresh_rate = specialGetter(base_refresh_rate);

        MethodInvocation methodInvocation(invocation);
        SetMode(
            (p_width),
            (p_height),
            (p_refresh_rate),
            methodInvocation);
    }

    if (method_name.compare("SetModeById") == 0) {
        Glib::Variant<guint32> base_id;
        parameters.get_child(base_id, 0);
        guint32 p_id = specialGetter(base_id);

        MethodInvocation methodInvocation(invocation);
        SetModeById(
            (p_id),
            methodInvocation);
    }

    if (method_name.compare("SetModeBySize") == 0) {
        Glib::Variant<guint32> base_width;
        parameters.get_child(base_width, 0);
        guint32 p_width = specialGetter(base_width);

        Glib::Variant<guint32> base_height;
        parameters.get_child(base_height, 1);
        guint32 p_height = specialGetter(base_height);

        MethodInvocation methodInvocation(invocation);
        SetModeBySize(
            (p_width),
            (p_height),
            methodInvocation);
    }

    if (method_name.compare("SetPosition") == 0) {
        Glib::Variant<gint32> base_x;
        parameters.get_child(base_x, 0);
        gint32 p_x = specialGetter(base_x);

        Glib::Variant<gint32> base_y;
        parameters.get_child(base_y, 1);
        gint32 p_y = specialGetter(base_y);

        MethodInvocation methodInvocation(invocation);
        SetPosition(
            (p_x),
            (p_y),
            methodInvocation);
    }

    if (method_name.compare("SetRotation") == 0) {
        Glib::Variant<guint16> base_rotation;
        parameters.get_child(base_rotation, 0);
        guint16 p_rotation = specialGetter(base_rotation);

        MethodInvocation methodInvocation(invocation);
        SetRotation(
            (p_rotation),
            methodInvocation);
    }

    if (method_name.compare("SetReflect") == 0) {
        Glib::Variant<guint16> base_reflect;
        parameters.get_child(base_reflect, 0);
        guint16 p_reflect = specialGetter(base_reflect);

        MethodInvocation methodInvocation(invocation);
        SetReflect(
            (p_reflect),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::Display::MonitorStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("id") == 0) {

        property = Glib::Variant<guint32>::create((id_get()));
    }

    if (property_name.compare("name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((name_get()));
    }

    if (property_name.compare("connected") == 0) {

        property = Glib::Variant<bool>::create((connected_get()));
    }

    if (property_name.compare("enabled") == 0) {

        property = Glib::Variant<bool>::create((enabled_get()));
    }

    if (property_name.compare("x") == 0) {

        property = Glib::Variant<gint32>::create((x_get()));
    }

    if (property_name.compare("y") == 0) {

        property = Glib::Variant<gint32>::create((y_get()));
    }

    if (property_name.compare("rotation") == 0) {

        property = Glib::Variant<guint16>::create((rotation_get()));
    }

    if (property_name.compare("reflect") == 0) {

        property = Glib::Variant<guint16>::create((reflect_get()));
    }

    if (property_name.compare("rotations") == 0) {

        property = Glib::Variant<std::vector<guint16>>::create((rotations_get()));
    }

    if (property_name.compare("reflects") == 0) {

        property = Glib::Variant<std::vector<guint16>>::create((reflects_get()));
    }

    if (property_name.compare("current_mode") == 0) {

        property = Glib::Variant<guint32>::create((current_mode_get()));
    }

    if (property_name.compare("modes") == 0) {

        property = Glib::Variant<std::vector<guint32>>::create((modes_get()));
    }

    if (property_name.compare("npreferred") == 0) {

        property = Glib::Variant<gint32>::create((npreferred_get()));
    }

}

bool Kiran::SessionDaemon::Display::MonitorStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SessionDaemon::Display::MonitorStub::id_set(guint32 value)
{
    if (id_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((id_get()));

        emitSignal("id", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::name_set(const Glib::ustring & value)
{
    if (name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((name_get()));

        emitSignal("name", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::connected_set(bool value)
{
    if (connected_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((connected_get()));

        emitSignal("connected", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::enabled_set(bool value)
{
    if (enabled_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((enabled_get()));

        emitSignal("enabled", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::x_set(gint32 value)
{
    if (x_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((x_get()));

        emitSignal("x", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::y_set(gint32 value)
{
    if (y_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((y_get()));

        emitSignal("y", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::rotation_set(guint16 value)
{
    if (rotation_setHandler(value)) {
        Glib::Variant<guint16> value_get =
            Glib::Variant<guint16>::create((rotation_get()));

        emitSignal("rotation", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::reflect_set(guint16 value)
{
    if (reflect_setHandler(value)) {
        Glib::Variant<guint16> value_get =
            Glib::Variant<guint16>::create((reflect_get()));

        emitSignal("reflect", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::rotations_set(const std::vector<guint16> & value)
{
    if (rotations_setHandler(value)) {
        Glib::Variant<std::vector<guint16>> value_get =
            Glib::Variant<std::vector<guint16>>::create((rotations_get()));

        emitSignal("rotations", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::reflects_set(const std::vector<guint16> & value)
{
    if (reflects_setHandler(value)) {
        Glib::Variant<std::vector<guint16>> value_get =
            Glib::Variant<std::vector<guint16>>::create((reflects_get()));

        emitSignal("reflects", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::current_mode_set(guint32 value)
{
    if (current_mode_setHandler(value)) {
        Glib::Variant<guint32> value_get =
            Glib::Variant<guint32>::create((current_mode_get()));

        emitSignal("current_mode", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::modes_set(const std::vector<guint32> & value)
{
    if (modes_setHandler(value)) {
        Glib::Variant<std::vector<guint32>> value_get =
            Glib::Variant<std::vector<guint32>>::create((modes_get()));

        emitSignal("modes", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::npreferred_set(gint32 value)
{
    if (npreferred_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((npreferred_get()));

        emitSignal("npreferred", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::Display::MonitorStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
