static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.Power">

        <!--<method name="GetAvaliableIdleActions">
            <arg type="i" name="device" direction="in">
                <description>The idle device that could be 'computer' or 'monitor'.</description>
            </arg>
            <arg type="i" name="actions_mask" direction="out">
                <description>The actions mask. If the bit is 1, then associate action is avaliable</description>
            </arg>
            <description>Get the avaliable actions for the specified device.</description>
        </method>-->

        <method name="SetIdleAction">
            <arg type="i" name="device" direction="in">
                <description>The device could be computer or backlight. Refer to PowerDeviceType definition in power-i.h</description>
            </arg>
            <arg type="i" name="supply" direction="in">
                <description>Refer to PowerSupplyMode definition in power-i.h.</description>
            </arg>
            <arg type="i" name="idle_timeout" direction="in">
                <description>The idle timeout in seconds. If the value is less than or equal to 0, then the idle action will be cancel and the action field is ignored.</description>
            </arg>
            <arg type="i" name="action" direction="in">
                <description>Refer to PowerAction definition in power-i.h, etc.</description>
            </arg>
            <description>If the idle time of the device exceed idle_timeout, then it will trigger the action.</description>
        </method>

        <method name="GetIdleAction">
            <arg type="i" name="device" direction="in" />
            <arg type="i" name="supply" direction="in" />
            <arg type="(ii)" name="idle_action" direction="out">
                <description>The field contains idle timeout and action.</description>
            </arg>
            <description>Get the idle action for the specified device on the supply.</description>
        </method>

        <method name="SetEventAction">
            <arg type="i" name="event" direction="in">
                <description>Refer to PowerEvent definition in power-i.h.</description>
            </arg>
            <arg type="i" name="action" direction="in">
                <summary>The triggered action.</summary>
            </arg>
            <description>The action is triggered when the event is happened.</description>
        </method>

        <method name="GetEventAction">
            <arg type="i" name="event" direction="in" />
            <arg type="i" name="action" direction="out" />
            <description>The action when the event is happened.</description>
        </method>

        <method name="SetBrightness">
            <arg type="i" name="device" direction="in">
                <description>The device could be monitor or keyboard. Refer to PowerDeviceType definition in power-i.h</description>
            </arg>
            <arg type="i" name="brightness_percentage" direction="in">
                <summary>The brightness percentage.</summary>
            </arg>
            <description>Set the brightness percentage for the specified device.</description>
        </method>

        <method name="GetBrightness">
            <arg type="i" name="device" direction="in" />
            <arg type="i" name="brightness_percentage" direction="out" />
            <description>Get the brightness percentage for the specified device. Return -1 if the device doesn't support brightness setting.</description>
        </method>

        <method name="SetIdleDimmed">
            <arg type="i" name="scale" direction="in">
                <description>The range of value is [0, 100].</description>
            </arg>
            <description>Set display dimmed scale when computer is idle.</description>
        </method>

        <property name="on_battery" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>Indicates whether the system is running on battery power.</description>
        </property>

        <property name="lid_is_present" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>If the system has a lid device.</description>
        </property>

        <property name="idle_dimmed_scale" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <description>The display dimmed scale when computer is idle. The range of value is [0, 100].</description>
        </property>

        <signal name="IdleActionChanged">
            <arg name="device" type="i" />
            <arg name="supply" type="i" />
        </signal>

        <signal name="EventActionChanged">
            <arg name="event" type="i" />
        </signal>

        <signal name="BrightnessChanged">
            <arg name="device" type="i" />
        </signal>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/power_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::PowerStub::PowerStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.Power")
{
    IdleActionChanged_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &PowerStub::IdleActionChanged_emitter),
            std::vector<Glib::ustring>({""})) );
    IdleActionChanged_selectiveSignal.connect(sigc::mem_fun(this, &PowerStub::IdleActionChanged_emitter));
    EventActionChanged_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &PowerStub::EventActionChanged_emitter),
            std::vector<Glib::ustring>({""})) );
    EventActionChanged_selectiveSignal.connect(sigc::mem_fun(this, &PowerStub::EventActionChanged_emitter));
    BrightnessChanged_signal.connect(sigc::bind<0>(sigc::mem_fun(this, &PowerStub::BrightnessChanged_emitter),
            std::vector<Glib::ustring>({""})) );
    BrightnessChanged_selectiveSignal.connect(sigc::mem_fun(this, &PowerStub::BrightnessChanged_emitter));
}

Kiran::SessionDaemon::PowerStub::~PowerStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::PowerStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &PowerStub::on_method_call),
            sigc::mem_fun(this, &PowerStub::on_interface_get_property),
            sigc::mem_fun(this, &PowerStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.Power"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::PowerStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::PowerStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("SetIdleAction") == 0) {
        Glib::Variant<gint32> base_device;
        parameters.get_child(base_device, 0);
        gint32 p_device = specialGetter(base_device);

        Glib::Variant<gint32> base_supply;
        parameters.get_child(base_supply, 1);
        gint32 p_supply = specialGetter(base_supply);

        Glib::Variant<gint32> base_idle_timeout;
        parameters.get_child(base_idle_timeout, 2);
        gint32 p_idle_timeout = specialGetter(base_idle_timeout);

        Glib::Variant<gint32> base_action;
        parameters.get_child(base_action, 3);
        gint32 p_action = specialGetter(base_action);

        MethodInvocation methodInvocation(invocation);
        SetIdleAction(
            (p_device),
            (p_supply),
            (p_idle_timeout),
            (p_action),
            methodInvocation);
    }

    if (method_name.compare("GetIdleAction") == 0) {
        Glib::Variant<gint32> base_device;
        parameters.get_child(base_device, 0);
        gint32 p_device = specialGetter(base_device);

        Glib::Variant<gint32> base_supply;
        parameters.get_child(base_supply, 1);
        gint32 p_supply = specialGetter(base_supply);

        MethodInvocation methodInvocation(invocation);
        GetIdleAction(
            (p_device),
            (p_supply),
            methodInvocation);
    }

    if (method_name.compare("SetEventAction") == 0) {
        Glib::Variant<gint32> base_event;
        parameters.get_child(base_event, 0);
        gint32 p_event = specialGetter(base_event);

        Glib::Variant<gint32> base_action;
        parameters.get_child(base_action, 1);
        gint32 p_action = specialGetter(base_action);

        MethodInvocation methodInvocation(invocation);
        SetEventAction(
            (p_event),
            (p_action),
            methodInvocation);
    }

    if (method_name.compare("GetEventAction") == 0) {
        Glib::Variant<gint32> base_event;
        parameters.get_child(base_event, 0);
        gint32 p_event = specialGetter(base_event);

        MethodInvocation methodInvocation(invocation);
        GetEventAction(
            (p_event),
            methodInvocation);
    }

    if (method_name.compare("SetBrightness") == 0) {
        Glib::Variant<gint32> base_device;
        parameters.get_child(base_device, 0);
        gint32 p_device = specialGetter(base_device);

        Glib::Variant<gint32> base_brightness_percentage;
        parameters.get_child(base_brightness_percentage, 1);
        gint32 p_brightness_percentage = specialGetter(base_brightness_percentage);

        MethodInvocation methodInvocation(invocation);
        SetBrightness(
            (p_device),
            (p_brightness_percentage),
            methodInvocation);
    }

    if (method_name.compare("GetBrightness") == 0) {
        Glib::Variant<gint32> base_device;
        parameters.get_child(base_device, 0);
        gint32 p_device = specialGetter(base_device);

        MethodInvocation methodInvocation(invocation);
        GetBrightness(
            (p_device),
            methodInvocation);
    }

    if (method_name.compare("SetIdleDimmed") == 0) {
        Glib::Variant<gint32> base_scale;
        parameters.get_child(base_scale, 0);
        gint32 p_scale = specialGetter(base_scale);

        MethodInvocation methodInvocation(invocation);
        SetIdleDimmed(
            (p_scale),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::PowerStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("on_battery") == 0) {

        property = Glib::Variant<bool>::create((on_battery_get()));
    }

    if (property_name.compare("lid_is_present") == 0) {

        property = Glib::Variant<bool>::create((lid_is_present_get()));
    }

    if (property_name.compare("idle_dimmed_scale") == 0) {

        property = Glib::Variant<gint32>::create((idle_dimmed_scale_get()));
    }

}

bool Kiran::SessionDaemon::PowerStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}

void Kiran::SessionDaemon::PowerStub::IdleActionChanged_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,gint32 device, gint32 supply)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<gint32>::create((device)));;
    paramsList.push_back(Glib::Variant<gint32>::create((supply)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Power",
                    "IdleActionChanged",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::PowerStub::EventActionChanged_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,gint32 event)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<gint32>::create((event)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Power",
                    "EventActionChanged",
                    bus_name,
                    params);
        }
    }
}

void Kiran::SessionDaemon::PowerStub::BrightnessChanged_emitter(
    const std::vector<Glib::ustring> &destination_bus_names,gint32 device)
{
    std::vector<Glib::VariantBase> paramsList;

    paramsList.push_back(Glib::Variant<gint32>::create((device)));;

    const Glib::VariantContainerBase params =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(paramsList);
    for (const RegisteredObject &obj: m_registered_objects) {
        for (const auto &bus_name: destination_bus_names) {
            obj.connection->emit_signal(
                    obj.object_path,
                    "com.kylinsec.Kiran.SessionDaemon.Power",
                    "BrightnessChanged",
                    bus_name,
                    params);
        }
    }
}


bool Kiran::SessionDaemon::PowerStub::on_battery_set(bool value)
{
    if (on_battery_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((on_battery_get()));

        emitSignal("on_battery", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::PowerStub::lid_is_present_set(bool value)
{
    if (lid_is_present_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((lid_is_present_get()));

        emitSignal("lid_is_present", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::PowerStub::idle_dimmed_scale_set(gint32 value)
{
    if (idle_dimmed_scale_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((idle_dimmed_scale_get()));

        emitSignal("idle_dimmed_scale", value_get);
        return true;
    }

    return false;
}

bool Kiran::SessionDaemon::PowerStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
