static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SystemDaemon.SystemInfo">

        <method name="GetSystemInfo">
            <arg type="i" name="type" direction="in">
                <doc:doc>
                    <doc:summary>The type could contain SYSTEMINFO_TYPE_SOFTWARE and SYSTEMINFO_TYPE_HARDWARE.</doc:summary>
                </doc:doc>
            </arg>
            <arg type="s" name="info" direction="out">
                <doc:doc>
                    <doc:summary>A json string that contains some system infomation.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>Get system infomation for specified type.</doc:description>
            </doc:doc>
        </method>

        <method name="SetHostName">
            <arg type="s" name="host_name" direction="in">
                <doc:doc>
                    <doc:summary>The host name.</doc:summary>
                </doc:doc>
            </arg>
            <doc:doc>
                <doc:description>Set host name.</doc:description>
            </doc:doc>
        </method>


        <property name="host_name" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true"/>
            <doc:doc>
                <doc:description>The host name.</doc:description>
            </doc:doc>
        </property>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/systeminfo_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SystemDaemon::SystemInfoStub::SystemInfoStub():
    m_interfaceName("com.kylinsec.Kiran.SystemDaemon.SystemInfo")
{
}

Kiran::SystemDaemon::SystemInfoStub::~SystemInfoStub()
{
    unregister_object();
}

guint Kiran::SystemDaemon::SystemInfoStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &SystemInfoStub::on_method_call),
            sigc::mem_fun(this, &SystemInfoStub::on_interface_get_property),
            sigc::mem_fun(this, &SystemInfoStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SystemDaemon.SystemInfo"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SystemDaemon::SystemInfoStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SystemDaemon::SystemInfoStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("GetSystemInfo") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        MethodInvocation methodInvocation(invocation);
        GetSystemInfo(
            (p_type),
            methodInvocation);
    }

    if (method_name.compare("SetHostName") == 0) {
        Glib::Variant<Glib::ustring> base_host_name;
        parameters.get_child(base_host_name, 0);
        Glib::ustring p_host_name = specialGetter(base_host_name);

        MethodInvocation methodInvocation(invocation);
        SetHostName(
            (p_host_name),
            methodInvocation);
    }

}

void Kiran::SystemDaemon::SystemInfoStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("host_name") == 0) {

        property = Glib::Variant<Glib::ustring>::create((host_name_get()));
    }

}

bool Kiran::SystemDaemon::SystemInfoStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SystemDaemon::SystemInfoStub::host_name_set(const Glib::ustring & value)
{
    if (host_name_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((host_name_get()));

        emitSignal("host_name", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::SystemInfoStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
