#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/timedate_dbus_common.h"

namespace Kiran {
namespace SystemDaemon {

class TimeDateProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<TimeDateProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<TimeDateProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void SetTime(
        gint64 requested_time,
        bool relative,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetTime_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetTime_sync(
        gint64 requested_time,        bool relative,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetTimezone(
        const Glib::ustring & time_zone,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetTimezone_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetTimezone_sync(
        const Glib::ustring & time_zone,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetZoneList(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetZoneList_finish (
        std::vector<std::tuple<Glib::ustring,Glib::ustring,gint64>> &zone_list,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<std::tuple<Glib::ustring,Glib::ustring,gint64>>
    GetZoneList_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLocalRTC(
        bool local,
        bool adjust_system,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLocalRTC_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetLocalRTC_sync(
        bool local,        bool adjust_system,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetNTP(
        bool active,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetNTP_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetNTP_sync(
        bool active,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDateFormatList(
        gint32 type,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetDateFormatList_finish (
        std::vector<Glib::ustring> &formats,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    GetDateFormatList_sync(
        gint32 type,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDateFormatByIndex(
        gint32 type,
        gint32 index,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetDateFormatByIndex_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetDateFormatByIndex_sync(
        gint32 type,        gint32 index,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetHourFormat(
        gint32 format,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetHourFormat_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetHourFormat_sync(
        gint32 format,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void EnableSecondsShowing(
        bool enabled,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void EnableSecondsShowing_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    EnableSecondsShowing_sync(
        bool enabled,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    Glib::ustring time_zone_get(bool *ok = nullptr);
    sigc::signal<void> &time_zone_changed() {
        return m_time_zone_changed;
    }

    bool local_rtc_get(bool *ok = nullptr);
    sigc::signal<void> &local_rtc_changed() {
        return m_local_rtc_changed;
    }

    bool can_ntp_get(bool *ok = nullptr);
    sigc::signal<void> &can_ntp_changed() {
        return m_can_ntp_changed;
    }

    bool ntp_get(bool *ok = nullptr);
    sigc::signal<void> &ntp_changed() {
        return m_ntp_changed;
    }

    guint64 system_time_get(bool *ok = nullptr);
    sigc::signal<void> &system_time_changed() {
        return m_system_time_changed;
    }

    guint64 rtc_time_get(bool *ok = nullptr);
    sigc::signal<void> &rtc_time_changed() {
        return m_rtc_time_changed;
    }

    gint32 date_long_format_index_get(bool *ok = nullptr);
    sigc::signal<void> &date_long_format_index_changed() {
        return m_date_long_format_index_changed;
    }

    gint32 date_short_format_index_get(bool *ok = nullptr);
    sigc::signal<void> &date_short_format_index_changed() {
        return m_date_short_format_index_changed;
    }

    gint32 hour_format_get(bool *ok = nullptr);
    sigc::signal<void> &hour_format_changed() {
        return m_hour_format_changed;
    }

    bool seconds_showing_get(bool *ok = nullptr);
    sigc::signal<void> &seconds_showing_changed() {
        return m_seconds_showing_changed;
    }


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    TimeDateProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_time_zone_changed;
    sigc::signal<void> m_local_rtc_changed;
    sigc::signal<void> m_can_ntp_changed;
    sigc::signal<void> m_ntp_changed;
    sigc::signal<void> m_system_time_changed;
    sigc::signal<void> m_rtc_time_changed;
    sigc::signal<void> m_date_long_format_index_changed;
    sigc::signal<void> m_date_short_format_index_changed;
    sigc::signal<void> m_hour_format_changed;
    sigc::signal<void> m_seconds_showing_changed;
};

}// SystemDaemon
}// Kiran

