static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SystemDaemon.TimeDate">
        <method name="SetTime">
            <arg type="x" name="requested_time" direction="in">
                <description>Time to set in microsecond.</description>
            </arg>
            <arg type="b" name="relative" direction="in">
                <description>Sets relative time since current time if true. Otherwise, sets the time since the Epoch</description>
            </arg>
            <description>Sets system time.</description>
        </method>

        <method name="SetTimezone">
            <arg type="s" name="time_zone" direction="in">
                <summary>Timezone</summary>
            </arg>
            <description>Sets system timezone.</description>
        </method>

        <method name="GetZoneList">
            <arg type="a(ssx)" name="zone_list" direction="out">
                <summary>Zone list</summary>
            </arg>
            <description>Get zone list. The element of the list contains zone name, locale zone name and GMT.</description>
        </method>

        <method name="SetLocalRTC">
            <arg type="b" name="local" direction="in">
                <description>The RTC timescale is Local if true. Otherwise, the RTC timescale is UTC.</description>
            </arg>
            <arg type="b" name="adjust_system" direction="in">
                <description>Sets the system time from the RTC if true. Otherwise, sets the RTC from the system time.</description>
            </arg>
            <description>Changes hardware clock time.</description>
        </method>

        <method name="SetNTP">
            <arg type="b" name="active" direction="in">
                <description>Enable NTP if true. Otherwise, Disable NTP.</description>
            </arg>
            <description>Enable or disable network time synchronization.</description>
        </method>

        <method name="GetDateFormatList">
            <arg type="i" name="type" direction="in">
                <description>Refer to enum TimedateDateFormatType in timedate-i.h.</description>
            </arg>
            <arg type="as" name="formats" direction="out">
                <description>The list of optional date format.</description>
            </arg>
            <description>Get the list of optional date format by type.</description>
        </method>

        <method name="SetDateFormatByIndex">
            <arg type="i" name="type" direction="in">
                <description>Refer to enum TimedateDateFormatType in timedate-i.h.</description>
            </arg>
            <arg type="i" name="index" direction="in">
                <description>The index in date format list.</description>
            </arg>
            <description>Set the date format of the specified type by index.</description>
        </method>

        <method name="SetHourFormat">
            <arg type="i" name="format" direction="in">
                <description>Refer to enum TimedateHourFormat in timedate-i.h.</description>
            </arg>
            <description>Set the hour show format which contain 12-hours and 24-hours.</description>
        </method>

        <method name="EnableSecondsShowing">
            <arg type="b" name="enabled" direction="in">
                <description>Whether show seconds in the time.</description>
            </arg>
            <description>Set whether show seconds in the time.</description>
        </method>

        <property name="time_zone" type="s" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>The system timezone.</description>
        </property>

        <property name="local_rtc" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>The RTC timescale, local or UTC.</description>
        </property>

        <property name="can_ntp" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>Whether the NTP server is avaliable.</description>
        </property>

        <property name="ntp" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>Whether the NTP server is enable.</description>
        </property>

        <property name="system_time" type="t" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="false" />
            <description>The system time in microsecond.</description>
        </property>

        <property name="rtc_time" type="t" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="false" />
            <description>The hardware time in microsecond.</description>
        </property>

        <property name="date_long_format_index" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>The index in long datetime format list.</description>
        </property>

        <property name="date_short_format_index" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>The index in short datetime format list.</description>
        </property>

        <property name="hour_format" type="i" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>The hour show format.</description>
        </property>

        <property name="seconds_showing" type="b" access="read">
            <annotation name="org.freedesktop.DBus.Property.EmitsChangedSignal" value="true" />
            <description>Whether show seconds in the time.</description>
        </property>
    </interface>
</node>)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/timedate_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SystemDaemon::TimeDateStub::TimeDateStub():
    m_interfaceName("com.kylinsec.Kiran.SystemDaemon.TimeDate")
{
}

Kiran::SystemDaemon::TimeDateStub::~TimeDateStub()
{
    unregister_object();
}

guint Kiran::SystemDaemon::TimeDateStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &TimeDateStub::on_method_call),
            sigc::mem_fun(this, &TimeDateStub::on_interface_get_property),
            sigc::mem_fun(this, &TimeDateStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SystemDaemon.TimeDate"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SystemDaemon::TimeDateStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SystemDaemon::TimeDateStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("SetTime") == 0) {
        Glib::Variant<gint64> base_requested_time;
        parameters.get_child(base_requested_time, 0);
        gint64 p_requested_time = specialGetter(base_requested_time);

        Glib::Variant<bool> base_relative;
        parameters.get_child(base_relative, 1);
        bool p_relative = specialGetter(base_relative);

        MethodInvocation methodInvocation(invocation);
        SetTime(
            (p_requested_time),
            (p_relative),
            methodInvocation);
    }

    if (method_name.compare("SetTimezone") == 0) {
        Glib::Variant<Glib::ustring> base_time_zone;
        parameters.get_child(base_time_zone, 0);
        Glib::ustring p_time_zone = specialGetter(base_time_zone);

        MethodInvocation methodInvocation(invocation);
        SetTimezone(
            (p_time_zone),
            methodInvocation);
    }

    if (method_name.compare("GetZoneList") == 0) {
        MethodInvocation methodInvocation(invocation);
        GetZoneList(
            methodInvocation);
    }

    if (method_name.compare("SetLocalRTC") == 0) {
        Glib::Variant<bool> base_local;
        parameters.get_child(base_local, 0);
        bool p_local = specialGetter(base_local);

        Glib::Variant<bool> base_adjust_system;
        parameters.get_child(base_adjust_system, 1);
        bool p_adjust_system = specialGetter(base_adjust_system);

        MethodInvocation methodInvocation(invocation);
        SetLocalRTC(
            (p_local),
            (p_adjust_system),
            methodInvocation);
    }

    if (method_name.compare("SetNTP") == 0) {
        Glib::Variant<bool> base_active;
        parameters.get_child(base_active, 0);
        bool p_active = specialGetter(base_active);

        MethodInvocation methodInvocation(invocation);
        SetNTP(
            (p_active),
            methodInvocation);
    }

    if (method_name.compare("GetDateFormatList") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        MethodInvocation methodInvocation(invocation);
        GetDateFormatList(
            (p_type),
            methodInvocation);
    }

    if (method_name.compare("SetDateFormatByIndex") == 0) {
        Glib::Variant<gint32> base_type;
        parameters.get_child(base_type, 0);
        gint32 p_type = specialGetter(base_type);

        Glib::Variant<gint32> base_index;
        parameters.get_child(base_index, 1);
        gint32 p_index = specialGetter(base_index);

        MethodInvocation methodInvocation(invocation);
        SetDateFormatByIndex(
            (p_type),
            (p_index),
            methodInvocation);
    }

    if (method_name.compare("SetHourFormat") == 0) {
        Glib::Variant<gint32> base_format;
        parameters.get_child(base_format, 0);
        gint32 p_format = specialGetter(base_format);

        MethodInvocation methodInvocation(invocation);
        SetHourFormat(
            (p_format),
            methodInvocation);
    }

    if (method_name.compare("EnableSecondsShowing") == 0) {
        Glib::Variant<bool> base_enabled;
        parameters.get_child(base_enabled, 0);
        bool p_enabled = specialGetter(base_enabled);

        MethodInvocation methodInvocation(invocation);
        EnableSecondsShowing(
            (p_enabled),
            methodInvocation);
    }

}

void Kiran::SystemDaemon::TimeDateStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

    if (property_name.compare("time_zone") == 0) {

        property = Glib::Variant<Glib::ustring>::create((time_zone_get()));
    }

    if (property_name.compare("local_rtc") == 0) {

        property = Glib::Variant<bool>::create((local_rtc_get()));
    }

    if (property_name.compare("can_ntp") == 0) {

        property = Glib::Variant<bool>::create((can_ntp_get()));
    }

    if (property_name.compare("ntp") == 0) {

        property = Glib::Variant<bool>::create((ntp_get()));
    }

    if (property_name.compare("system_time") == 0) {

        property = Glib::Variant<guint64>::create((system_time_get()));
    }

    if (property_name.compare("rtc_time") == 0) {

        property = Glib::Variant<guint64>::create((rtc_time_get()));
    }

    if (property_name.compare("date_long_format_index") == 0) {

        property = Glib::Variant<gint32>::create((date_long_format_index_get()));
    }

    if (property_name.compare("date_short_format_index") == 0) {

        property = Glib::Variant<gint32>::create((date_short_format_index_get()));
    }

    if (property_name.compare("hour_format") == 0) {

        property = Glib::Variant<gint32>::create((hour_format_get()));
    }

    if (property_name.compare("seconds_showing") == 0) {

        property = Glib::Variant<bool>::create((seconds_showing_get()));
    }

}

bool Kiran::SystemDaemon::TimeDateStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SystemDaemon::TimeDateStub::time_zone_set(const Glib::ustring & value)
{
    if (time_zone_setHandler(value)) {
        Glib::Variant<Glib::ustring> value_get =
            Glib::Variant<Glib::ustring>::create((time_zone_get()));

        emitSignal("time_zone", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::local_rtc_set(bool value)
{
    if (local_rtc_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((local_rtc_get()));

        emitSignal("local_rtc", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::can_ntp_set(bool value)
{
    if (can_ntp_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((can_ntp_get()));

        emitSignal("can_ntp", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::ntp_set(bool value)
{
    if (ntp_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((ntp_get()));

        emitSignal("ntp", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::system_time_set(guint64 value)
{
    if (system_time_setHandler(value)) {
        Glib::Variant<guint64> value_get =
            Glib::Variant<guint64>::create((system_time_get()));

        emitSignal("system_time", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::rtc_time_set(guint64 value)
{
    if (rtc_time_setHandler(value)) {
        Glib::Variant<guint64> value_get =
            Glib::Variant<guint64>::create((rtc_time_get()));

        emitSignal("rtc_time", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::date_long_format_index_set(gint32 value)
{
    if (date_long_format_index_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((date_long_format_index_get()));

        emitSignal("date_long_format_index", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::date_short_format_index_set(gint32 value)
{
    if (date_short_format_index_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((date_short_format_index_get()));

        emitSignal("date_short_format_index", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::hour_format_set(gint32 value)
{
    if (hour_format_setHandler(value)) {
        Glib::Variant<gint32> value_get =
            Glib::Variant<gint32>::create((hour_format_get()));

        emitSignal("hour_format", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::seconds_showing_set(bool value)
{
    if (seconds_showing_setHandler(value)) {
        Glib::Variant<bool> value_get =
            Glib::Variant<bool>::create((seconds_showing_get()));

        emitSignal("seconds_showing", value_get);
        return true;
    }

    return false;
}

bool Kiran::SystemDaemon::TimeDateStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
