#pragma once
#include <iostream>
#include <vector>
#include "glibmm.h"
#include "giomm.h"

namespace Kiran {
namespace SystemDaemon {
namespace Accounts {

class UserTypeWrap {
public:
    template<typename T>
    static void unwrapList(std::vector<T> &list, const Glib::VariantContainerBase &wrapped) {
        for (uint i = 0; i < wrapped.get_n_children(); i++) {
            Glib::Variant<T> item;
            wrapped.get_child(item, i);
            list.push_back(item.get());
        }
    }

    static std::vector<Glib::ustring> stdStringVecToGlibStringVec(const std::vector<std::string> &strv) {
        std::vector<Glib::ustring> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static std::vector<std::string> glibStringVecToStdStringVec(const std::vector<Glib::ustring> &strv) {
        std::vector<std::string> newStrv;
        for (uint i = 0; i < strv.size(); i++) {
            newStrv.push_back(strv[i]);
        }

        return newStrv;
    }

    static Glib::VariantContainerBase SetUserName_pack(
        const Glib::ustring & arg_name) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_name);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetRealName_pack(
        const Glib::ustring & arg_name) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_name);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetEmail_pack(
        const Glib::ustring & arg_email) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_email);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetLanguage_pack(
        const Glib::ustring & arg_language) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_language);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetXSession_pack(
        const Glib::ustring & arg_x_session) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_x_session);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetSession_pack(
        const Glib::ustring & arg_session) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_session);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetSessionType_pack(
        const Glib::ustring & arg_session_type) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_session_type);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetHomeDirectory_pack(
        const Glib::ustring & arg_homedir) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_homedir);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetShell_pack(
        const Glib::ustring & arg_shell) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_shell);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetIconFile_pack(
        const Glib::ustring & arg_filename) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_filename);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetLocked_pack(
        bool arg_locked) {
        Glib::VariantContainerBase base;
        Glib::Variant<bool> params =
            Glib::Variant<bool>::create(arg_locked);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetAccountType_pack(
        gint32 arg_account_type) {
        Glib::VariantContainerBase base;
        Glib::Variant<gint32> params =
            Glib::Variant<gint32>::create(arg_account_type);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetPasswordMode_pack(
        gint32 arg_mode) {
        Glib::VariantContainerBase base;
        Glib::Variant<gint32> params =
            Glib::Variant<gint32>::create(arg_mode);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetPassword_pack(
        const Glib::ustring & arg_password,
        const Glib::ustring & arg_hint) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::Variant<Glib::ustring> password_param =
            Glib::Variant<Glib::ustring>::create(arg_password);
        params.push_back(password_param);

        Glib::Variant<Glib::ustring> hint_param =
            Glib::Variant<Glib::ustring>::create(arg_hint);
        params.push_back(hint_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetPasswordHint_pack(
        const Glib::ustring & arg_hint) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_hint);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetAutomaticLogin_pack(
        bool arg_enabled) {
        Glib::VariantContainerBase base;
        Glib::Variant<bool> params =
            Glib::Variant<bool>::create(arg_enabled);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase SetPasswordExpirationPolicy_pack(
        const Glib::ustring & arg_options) {
        Glib::VariantContainerBase base;
        Glib::Variant<Glib::ustring> params =
            Glib::Variant<Glib::ustring>::create(arg_options);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase AddAuthItem_pack(
        gint32 arg_mode,
        const Glib::ustring & arg_name,
        const Glib::ustring & arg_data_id) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::Variant<gint32> mode_param =
            Glib::Variant<gint32>::create(arg_mode);
        params.push_back(mode_param);

        Glib::Variant<Glib::ustring> name_param =
            Glib::Variant<Glib::ustring>::create(arg_name);
        params.push_back(name_param);

        Glib::Variant<Glib::ustring> data_id_param =
            Glib::Variant<Glib::ustring>::create(arg_data_id);
        params.push_back(data_id_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase DelAuthItem_pack(
        gint32 arg_mode,
        const Glib::ustring & arg_name) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::Variant<gint32> mode_param =
            Glib::Variant<gint32>::create(arg_mode);
        params.push_back(mode_param);

        Glib::Variant<Glib::ustring> name_param =
            Glib::Variant<Glib::ustring>::create(arg_name);
        params.push_back(name_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase GetAuthItems_pack(
        gint32 arg_mode) {
        Glib::VariantContainerBase base;
        Glib::Variant<gint32> params =
            Glib::Variant<gint32>::create(arg_mode);
        return Glib::VariantContainerBase::create_tuple(params);
    }

    static Glib::VariantContainerBase EnableAuthMode_pack(
        gint32 arg_mode,
        bool arg_enabled) {
        Glib::VariantContainerBase base;
        std::vector<Glib::VariantBase> params;

        Glib::Variant<gint32> mode_param =
            Glib::Variant<gint32>::create(arg_mode);
        params.push_back(mode_param);

        Glib::Variant<bool> enabled_param =
            Glib::Variant<bool>::create(arg_enabled);
        params.push_back(enabled_param);
        return Glib::VariantContainerBase::create_tuple(params);
    }
};

} // Accounts
} // SystemDaemon
} // Kiran


