#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/user_dbus_common.h"

namespace Kiran {
namespace SystemDaemon {
namespace Accounts {

class UserProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<UserProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<UserProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void SetUserName(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetUserName_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetUserName_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetRealName(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetRealName_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetRealName_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetEmail(
        const Glib::ustring & email,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetEmail_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetEmail_sync(
        const Glib::ustring & email,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLanguage(
        const Glib::ustring & language,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLanguage_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetLanguage_sync(
        const Glib::ustring & language,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetXSession(
        const Glib::ustring & x_session,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetXSession_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetXSession_sync(
        const Glib::ustring & x_session,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetSession(
        const Glib::ustring & session,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetSession_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetSession_sync(
        const Glib::ustring & session,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetSessionType(
        const Glib::ustring & session_type,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetSessionType_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetSessionType_sync(
        const Glib::ustring & session_type,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetHomeDirectory(
        const Glib::ustring & homedir,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetHomeDirectory_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetHomeDirectory_sync(
        const Glib::ustring & homedir,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetShell(
        const Glib::ustring & shell,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetShell_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetShell_sync(
        const Glib::ustring & shell,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetIconFile(
        const Glib::ustring & filename,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetIconFile_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetIconFile_sync(
        const Glib::ustring & filename,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLocked(
        bool locked,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetLocked_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetLocked_sync(
        bool locked,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetAccountType(
        gint32 account_type,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetAccountType_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetAccountType_sync(
        gint32 account_type,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordMode(
        gint32 mode,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordMode_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetPasswordMode_sync(
        gint32 mode,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPassword(
        const Glib::ustring & password,
        const Glib::ustring & hint,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPassword_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetPassword_sync(
        const Glib::ustring & password,        const Glib::ustring & hint,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordHint(
        const Glib::ustring & hint,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordHint_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetPasswordHint_sync(
        const Glib::ustring & hint,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetAutomaticLogin(
        bool enabled,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetAutomaticLogin_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetAutomaticLogin_sync(
        bool enabled,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordExpirationPolicy(
        const Glib::ustring & options,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetPasswordExpirationPolicy_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetPasswordExpirationPolicy_sync(
        const Glib::ustring & options,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddAuthItem(
        gint32 mode,
        const Glib::ustring & name,
        const Glib::ustring & data_id,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void AddAuthItem_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    AddAuthItem_sync(
        gint32 mode,        const Glib::ustring & name,        const Glib::ustring & data_id,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelAuthItem(
        gint32 mode,
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void DelAuthItem_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    DelAuthItem_sync(
        gint32 mode,        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetAuthItems(
        gint32 mode,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetAuthItems_finish (
        Glib::ustring &auth_items_json,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetAuthItems_sync(
        gint32 mode,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void EnableAuthMode(
        gint32 mode,
        bool enabled,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void EnableAuthMode_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    EnableAuthMode_sync(
        gint32 mode,        bool enabled,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    guint64 uid_get(bool *ok = nullptr);
    sigc::signal<void> &uid_changed() {
        return m_uid_changed;
    }

    Glib::ustring user_name_get(bool *ok = nullptr);
    sigc::signal<void> &user_name_changed() {
        return m_user_name_changed;
    }

    Glib::ustring real_name_get(bool *ok = nullptr);
    sigc::signal<void> &real_name_changed() {
        return m_real_name_changed;
    }

    gint32 account_type_get(bool *ok = nullptr);
    sigc::signal<void> &account_type_changed() {
        return m_account_type_changed;
    }

    Glib::ustring home_directory_get(bool *ok = nullptr);
    sigc::signal<void> &home_directory_changed() {
        return m_home_directory_changed;
    }

    Glib::ustring shell_get(bool *ok = nullptr);
    sigc::signal<void> &shell_changed() {
        return m_shell_changed;
    }

    Glib::ustring email_get(bool *ok = nullptr);
    sigc::signal<void> &email_changed() {
        return m_email_changed;
    }

    Glib::ustring language_get(bool *ok = nullptr);
    sigc::signal<void> &language_changed() {
        return m_language_changed;
    }

    Glib::ustring session_get(bool *ok = nullptr);
    sigc::signal<void> &session_changed() {
        return m_session_changed;
    }

    Glib::ustring session_type_get(bool *ok = nullptr);
    sigc::signal<void> &session_type_changed() {
        return m_session_type_changed;
    }

    Glib::ustring x_session_get(bool *ok = nullptr);
    sigc::signal<void> &x_session_changed() {
        return m_x_session_changed;
    }

    Glib::ustring icon_file_get(bool *ok = nullptr);
    sigc::signal<void> &icon_file_changed() {
        return m_icon_file_changed;
    }

    bool locked_get(bool *ok = nullptr);
    sigc::signal<void> &locked_changed() {
        return m_locked_changed;
    }

    gint32 password_mode_get(bool *ok = nullptr);
    sigc::signal<void> &password_mode_changed() {
        return m_password_mode_changed;
    }

    Glib::ustring password_hint_get(bool *ok = nullptr);
    sigc::signal<void> &password_hint_changed() {
        return m_password_hint_changed;
    }

    bool automatic_login_get(bool *ok = nullptr);
    sigc::signal<void> &automatic_login_changed() {
        return m_automatic_login_changed;
    }

    bool system_account_get(bool *ok = nullptr);
    sigc::signal<void> &system_account_changed() {
        return m_system_account_changed;
    }

    gint32 auth_modes_get(bool *ok = nullptr);
    sigc::signal<void> &auth_modes_changed() {
        return m_auth_modes_changed;
    }

    Glib::ustring password_expiration_policy_get(bool *ok = nullptr);
    sigc::signal<void> &password_expiration_policy_changed() {
        return m_password_expiration_policy_changed;
    }

    sigc::signal<void, gint32 > AuthItemChanged_signal;

    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    UserProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

    sigc::signal<void> m_uid_changed;
    sigc::signal<void> m_user_name_changed;
    sigc::signal<void> m_real_name_changed;
    sigc::signal<void> m_account_type_changed;
    sigc::signal<void> m_home_directory_changed;
    sigc::signal<void> m_shell_changed;
    sigc::signal<void> m_email_changed;
    sigc::signal<void> m_language_changed;
    sigc::signal<void> m_session_changed;
    sigc::signal<void> m_session_type_changed;
    sigc::signal<void> m_x_session_changed;
    sigc::signal<void> m_icon_file_changed;
    sigc::signal<void> m_locked_changed;
    sigc::signal<void> m_password_mode_changed;
    sigc::signal<void> m_password_hint_changed;
    sigc::signal<void> m_automatic_login_changed;
    sigc::signal<void> m_system_account_changed;
    sigc::signal<void> m_auth_modes_changed;
    sigc::signal<void> m_password_expiration_policy_changed;
};

}// Accounts
}// SystemDaemon
}// Kiran

