#pragma once
#include <string>
#include <tuple>
#include <vector>
#include <glibmm.h>
#include <giomm.h>
#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/xsettings_dbus_common.h"

namespace Kiran {
namespace SessionDaemon {

class XSettingsProxy : public Glib::ObjectBase {
public:
    static void createForBus(Gio::DBus::BusType busType,
                             Gio::DBus::ProxyFlags proxyFlags,
                             const std::string &name,
                             const std::string &objectPath,
                             const Gio::SlotAsyncReady &slot,
                             const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    static Glib::RefPtr<XSettingsProxy> createForBusFinish (const Glib::RefPtr<Gio::AsyncResult> &result);

    static Glib::RefPtr<XSettingsProxy> createForBus_sync(
        Gio::DBus::BusType busType,
        Gio::DBus::ProxyFlags proxyFlags,
        const std::string &name,
        const std::string &objectPath,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {});

    Glib::RefPtr<Gio::DBus::Proxy> dbusProxy() const { return m_proxy; }

    void ListPropertyNames(
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void ListPropertyNames_finish (
        std::vector<Glib::ustring> &names,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::vector<Glib::ustring>
    ListPropertyNames_sync(
const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInteger(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetInteger_finish (
        gint32 &value,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    gint32
    GetInteger_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetInteger(
        const Glib::ustring & name,
        gint32 value,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetInteger_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetInteger_sync(
        const Glib::ustring & name,        gint32 value,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetString(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetString_finish (
        Glib::ustring &value,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    Glib::ustring
    GetString_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetString(
        const Glib::ustring & name,
        const Glib::ustring & value,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetString_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetString_sync(
        const Glib::ustring & name,        const Glib::ustring & value,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetColor(
        const Glib::ustring & name,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void GetColor_finish (
        std::tuple<guint16,guint16,guint16,guint16> &value,
        const Glib::RefPtr<Gio::AsyncResult> &res);

    std::tuple<guint16,guint16,guint16,guint16>
    GetColor_sync(
        const Glib::ustring & name,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetColor(
        const Glib::ustring & name,
        const std::tuple<guint16,guint16,guint16,guint16> & value,
        const Gio::SlotAsyncReady &slot,
        const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);

    void SetColor_finish (
        const Glib::RefPtr<Gio::AsyncResult> &res);

    void
    SetColor_sync(
        const Glib::ustring & name,        const std::tuple<guint16,guint16,guint16,guint16> & value,const Glib::RefPtr<Gio::Cancellable> &cancellable = {},
        int timeout_msec = -1);


    void reference() const override {}
    void unreference() const override {}

protected:
    Glib::RefPtr<Gio::DBus::Proxy> m_proxy;

private:
    XSettingsProxy(const Glib::RefPtr<Gio::DBus::Proxy> &proxy);

    void handle_signal(const Glib::ustring &sender_name,
                       const Glib::ustring &signal_name,
                       const Glib::VariantContainerBase &parameters);

    void handle_properties_changed(const Gio::DBus::Proxy::MapChangedProperties &changed_properties,
                                   const std::vector<Glib::ustring> &invalidated_properties);

};

}// SessionDaemon
}// Kiran

