static const char interfaceXml0[] = R"XML_DELIMITER(<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN" "http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node xmlns:doc="http://www.freedesktop.org/dbus/1.0/doc.dtd">
    <interface name="com.kylinsec.Kiran.SessionDaemon.XSettings">

        <method name="ListPropertyNames">
            <arg type="as" name="names" direction="out">
                <summary>The XSettings Registry property names list.</summary>
            </arg>
            <description>List all XSettings Registry property names.</description>
        </method>

        <method name="GetInteger">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="i" name="value" direction="out">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Get the XSettings Registry value whose type is integer.</description>
        </method>

        <method name="SetInteger">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="i" name="value" direction="in">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Set the XSettings Registry value type is integer.</description>
        </method>

        <method name="GetString">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="s" name="value" direction="out">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Get the XSettings Registry value whose type is string.</description>
        </method>

        <method name="SetString">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="s" name="value" direction="in">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Set the XSettings Registry value whose type is string.</description>
        </method>

        <method name="GetColor">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="(qqqq)" name="value" direction="out">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Get the XSettings Registry value whose type is color.</description>
        </method>

        <method name="SetColor">
            <arg type="s" name="name" direction="in">
                <summary>The XSettings Registry property name.</summary>
            </arg>
            <arg type="(qqqq)" name="value" direction="in">
                <summary>The XSettings Registry property value.</summary>
            </arg>
            <description>Set the XSettings Registry value whose type is color.</description>
        </method>

    </interface>
</node>
)XML_DELIMITER";

#include "/home/abuild/rpmbuild/BUILD/kiran-cc-daemon-2.1.0/generated/xsettings_dbus_stub.h"

template<class T>
inline T specialGetter(Glib::Variant<T> variant)
{
    return variant.get();
}

template<>
inline std::string specialGetter(Glib::Variant<std::string> variant)
{
    // String is not guaranteed to be null-terminated, so don't use ::get()
    gsize n_elem;
    gsize elem_size = sizeof(char);
    char* data = (char*)g_variant_get_fixed_array(variant.gobj(), &n_elem, elem_size);

    return std::string(data, n_elem);
}

Kiran::SessionDaemon::XSettingsStub::XSettingsStub():
    m_interfaceName("com.kylinsec.Kiran.SessionDaemon.XSettings")
{
}

Kiran::SessionDaemon::XSettingsStub::~XSettingsStub()
{
    unregister_object();
}

guint Kiran::SessionDaemon::XSettingsStub::register_object(
    const Glib::RefPtr<Gio::DBus::Connection> &connection,
    const Glib::ustring &object_path)
{
    if (!introspection_data) {
        try {
            introspection_data = Gio::DBus::NodeInfo::create_for_xml(interfaceXml0);
        } catch(const Glib::Error& ex) {
            g_warning("Unable to create introspection data for %s: %s", object_path.c_str(), ex.what().c_str());
            return 0;
        }
    }

    Gio::DBus::InterfaceVTable *interface_vtable =
        new Gio::DBus::InterfaceVTable(
            sigc::mem_fun(this, &XSettingsStub::on_method_call),
            sigc::mem_fun(this, &XSettingsStub::on_interface_get_property),
            sigc::mem_fun(this, &XSettingsStub::on_interface_set_property));

    guint registration_id;
    try {
        registration_id = connection->register_object(object_path,
            introspection_data->lookup_interface("com.kylinsec.Kiran.SessionDaemon.XSettings"),
            *interface_vtable);
    } catch(const Glib::Error &ex) {
        g_warning("Registration of object %s failed: %s", object_path.c_str(), ex.what().c_str());
        return 0;
    }

    m_registered_objects.emplace_back(RegisteredObject {
        registration_id,
        connection,
        object_path
    });

    return registration_id;
}

void Kiran::SessionDaemon::XSettingsStub::unregister_object()
{
    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->unregister_object(obj.id);
    }
    m_registered_objects.clear();
}

void Kiran::SessionDaemon::XSettingsStub::on_method_call(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &method_name,
    const Glib::VariantContainerBase &parameters,
    const Glib::RefPtr<Gio::DBus::MethodInvocation> &invocation)
{
    static_cast<void>(method_name); // maybe unused
    static_cast<void>(parameters); // maybe unused
    static_cast<void>(invocation); // maybe unused

    if (method_name.compare("ListPropertyNames") == 0) {
        MethodInvocation methodInvocation(invocation);
        ListPropertyNames(
            methodInvocation);
    }

    if (method_name.compare("GetInteger") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        MethodInvocation methodInvocation(invocation);
        GetInteger(
            (p_name),
            methodInvocation);
    }

    if (method_name.compare("SetInteger") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        Glib::Variant<gint32> base_value;
        parameters.get_child(base_value, 1);
        gint32 p_value = specialGetter(base_value);

        MethodInvocation methodInvocation(invocation);
        SetInteger(
            (p_name),
            (p_value),
            methodInvocation);
    }

    if (method_name.compare("GetString") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        MethodInvocation methodInvocation(invocation);
        GetString(
            (p_name),
            methodInvocation);
    }

    if (method_name.compare("SetString") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        Glib::Variant<Glib::ustring> base_value;
        parameters.get_child(base_value, 1);
        Glib::ustring p_value = specialGetter(base_value);

        MethodInvocation methodInvocation(invocation);
        SetString(
            (p_name),
            (p_value),
            methodInvocation);
    }

    if (method_name.compare("GetColor") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        MethodInvocation methodInvocation(invocation);
        GetColor(
            (p_name),
            methodInvocation);
    }

    if (method_name.compare("SetColor") == 0) {
        Glib::Variant<Glib::ustring> base_name;
        parameters.get_child(base_name, 0);
        Glib::ustring p_name = specialGetter(base_name);

        Glib::Variant<std::tuple<guint16,guint16,guint16,guint16>> base_value;
        parameters.get_child(base_value, 1);
        std::tuple<guint16,guint16,guint16,guint16> p_value = specialGetter(base_value);

        MethodInvocation methodInvocation(invocation);
        SetColor(
            (p_name),
            (p_value),
            methodInvocation);
    }

}

void Kiran::SessionDaemon::XSettingsStub::on_interface_get_property(
    Glib::VariantBase &property,
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name)
{
    static_cast<void>(property); // maybe unused
    static_cast<void>(property_name); // maybe unused

}

bool Kiran::SessionDaemon::XSettingsStub::on_interface_set_property(
    const Glib::RefPtr<Gio::DBus::Connection> &/* connection */,
    const Glib::ustring &/* sender */,
    const Glib::ustring &/* object_path */,
    const Glib::ustring &/* interface_name */,
    const Glib::ustring &property_name,
    const Glib::VariantBase &value)
{
    static_cast<void>(property_name); // maybe unused
    static_cast<void>(value); // maybe unused

    return true;
}


bool Kiran::SessionDaemon::XSettingsStub::emitSignal(
    const std::string &propName,
    Glib::VariantBase &value)
{
    std::map<Glib::ustring, Glib::VariantBase> changedProps;
    std::vector<Glib::ustring> changedPropsNoValue;

    changedProps[propName] = value;

    Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>> changedPropsVar =
        Glib::Variant<std::map<Glib::ustring, Glib::VariantBase>>::create(changedProps);
    Glib::Variant<std::vector<Glib::ustring>> changedPropsNoValueVar =
        Glib::Variant<std::vector<Glib::ustring>>::create(changedPropsNoValue);
    std::vector<Glib::VariantBase> ps;
    ps.push_back(Glib::Variant<Glib::ustring>::create(m_interfaceName));
    ps.push_back(changedPropsVar);
    ps.push_back(changedPropsNoValueVar);
    Glib::VariantContainerBase propertiesChangedVariant =
        Glib::Variant<std::vector<Glib::VariantBase>>::create_tuple(ps);

    for (const RegisteredObject &obj: m_registered_objects) {
        obj.connection->emit_signal(
            obj.object_path,
            "org.freedesktop.DBus.Properties",
            "PropertiesChanged",
            Glib::ustring(),
            propertiesChangedVariant);
    }

    return true;
}
